// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"errors"
	"sync"

	"go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"

	"go.opentelemetry.io/collector/component"
)

func Meter(settings component.TelemetrySettings) metric.Meter {
	return settings.MeterProvider.Meter("github.com/open-telemetry/opentelemetry-collector-contrib/exporter/sumologicexporter")
}

func Tracer(settings component.TelemetrySettings) trace.Tracer {
	return settings.TracerProvider.Tracer("github.com/open-telemetry/opentelemetry-collector-contrib/exporter/sumologicexporter")
}

// TelemetryBuilder provides an interface for components to report telemetry
// as defined in metadata and user config.
type TelemetryBuilder struct {
	meter                    metric.Meter
	mu                       sync.Mutex
	registrations            []metric.Registration
	ExporterRequestsBytes    metric.Int64Counter
	ExporterRequestsDuration metric.Int64Counter
	ExporterRequestsRecords  metric.Int64Counter
	ExporterRequestsSent     metric.Int64Counter
}

// TelemetryBuilderOption applies changes to default builder.
type TelemetryBuilderOption interface {
	apply(*TelemetryBuilder)
}

type telemetryBuilderOptionFunc func(mb *TelemetryBuilder)

func (tbof telemetryBuilderOptionFunc) apply(mb *TelemetryBuilder) {
	tbof(mb)
}

// Shutdown unregister all registered callbacks for async instruments.
func (builder *TelemetryBuilder) Shutdown() {
	builder.mu.Lock()
	defer builder.mu.Unlock()
	for _, reg := range builder.registrations {
		reg.Unregister()
	}
}

// NewTelemetryBuilder provides a struct with methods to update all internal telemetry
// for a component
func NewTelemetryBuilder(settings component.TelemetrySettings, options ...TelemetryBuilderOption) (*TelemetryBuilder, error) {
	builder := TelemetryBuilder{}
	for _, op := range options {
		op.apply(&builder)
	}
	builder.meter = Meter(settings)
	var err, errs error
	builder.ExporterRequestsBytes, err = builder.meter.Int64Counter(
		"otelcol_exporter_requests_bytes",
		metric.WithDescription("Total size of requests (in bytes)"),
		metric.WithUnit("By"),
	)
	errs = errors.Join(errs, err)
	builder.ExporterRequestsDuration, err = builder.meter.Int64Counter(
		"otelcol_exporter_requests_duration",
		metric.WithDescription("Duration of HTTP requests (in milliseconds)"),
		metric.WithUnit("ms"),
	)
	errs = errors.Join(errs, err)
	builder.ExporterRequestsRecords, err = builder.meter.Int64Counter(
		"otelcol_exporter_requests_records",
		metric.WithDescription("Total size of requests (in number of records)"),
		metric.WithUnit("{records}"),
	)
	errs = errors.Join(errs, err)
	builder.ExporterRequestsSent, err = builder.meter.Int64Counter(
		"otelcol_exporter_requests_sent",
		metric.WithDescription("Number of requests"),
		metric.WithUnit("1"),
	)
	errs = errors.Join(errs, err)
	return &builder, errs
}
