# TencentCloud LogService Exporter

<!-- status autogenerated section -->
| Status        |           |
| ------------- |-----------|
| Stability     | [beta]: logs   |
| Distributions | [contrib] |
| Issues        | [![Open issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aopen%20label%3Aexporter%2Ftencentcloudlogservice%20&label=open&color=orange&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aopen+is%3Aissue+label%3Aexporter%2Ftencentcloudlogservice) [![Closed issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aclosed%20label%3Aexporter%2Ftencentcloudlogservice%20&label=closed&color=blue&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aclosed+is%3Aissue+label%3Aexporter%2Ftencentcloudlogservice) |
| [Code Owners](https://github.com/open-telemetry/opentelemetry-collector-contrib/blob/main/CONTRIBUTING.md#becoming-a-code-owner)    | [@wgliang](https://www.github.com/wgliang) |
| Emeritus      | [@yiyang5055](https://www.github.com/yiyang5055) |

[beta]: https://github.com/open-telemetry/opentelemetry-collector/blob/main/docs/component-stability.md#beta
[contrib]: https://github.com/open-telemetry/opentelemetry-collector-releases/tree/main/distributions/otelcol-contrib
<!-- end autogenerated section -->

This exporter supports sending OpenTelemetry log data to [LogService](https://cloud.tencent.com/product/cls).

# Configuration options:

- `region` (required): LogService's [Region](https://cloud.tencent.com/document/product/614/56473).
- `logset` (required): LogService's LogSet ID.
- `topic` (required): LogService's topic ID.
- `secret_id` (optional): TencentCloud secret id.
- `secret_key` (optional): TencentCloud secret key.

# Example:
## Simple Log Data

```yaml
receivers:
  otlp:
    protocols:
      grpc:
        endpoint: ":4317"

exporters:
  tencentcloud_logservice:
      # LogService's Region, https://cloud.tencent.com/document/product/614/18940
      # set cls.{region}.tencentcloudapi.com, eg cls.ap-beijing.tencentcloudapi.com;
    region: "ap-beijing"
    # LogService's LogSet ID
    logset: "demo-logset"
    # LogService's Topic ID
    topic: "demo-topic"
    # TencentCloud secret id
    secret_id: "demo-secret-id"
    # TencentCloud secret key
    secret_key: "demo-secret-key"

service:
  pipelines:
    logs:
      receivers: [otlp]
      exporters: [tencentcloud_logservice]
```

# Changelog

- 2021-11-10 Change configuration item **endpoint** to **region**, by @wgliang
- 2021-11-01 Initial implementation by @wgliang in #5722
