# OpAMP Agent Extension
<!-- status autogenerated section -->
| Status        |           |
| ------------- |-----------|
| Stability     | [alpha]  |
| Distributions | [contrib], [k8s] |
| Issues        | [![Open issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aopen%20label%3Aextension%2Fopamp%20&label=open&color=orange&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aopen+is%3Aissue+label%3Aextension%2Fopamp) [![Closed issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aclosed%20label%3Aextension%2Fopamp%20&label=closed&color=blue&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aclosed+is%3Aissue+label%3Aextension%2Fopamp) |
| [Code Owners](https://github.com/open-telemetry/opentelemetry-collector-contrib/blob/main/CONTRIBUTING.md#becoming-a-code-owner)    | [@portertech](https://www.github.com/portertech), [@evan-bradley](https://www.github.com/evan-bradley), [@tigrannajaryan](https://www.github.com/tigrannajaryan) |

[alpha]: https://github.com/open-telemetry/opentelemetry-collector/blob/main/docs/component-stability.md#alpha
[contrib]: https://github.com/open-telemetry/opentelemetry-collector-releases/tree/main/distributions/otelcol-contrib
[k8s]: https://github.com/open-telemetry/opentelemetry-collector-releases/tree/main/distributions/otelcol-k8s
<!-- end autogenerated section -->

## Configuration

The following settings are required:

- `server`: The OpAMP server connection settings.
  - `ws`: The OpAMP websocket transport settings.
    - `endpoint` (no default): The OpAMP server websocket endpoint (URL).

The following settings are optional for the websocket client:

- `server`: The OpAMP server connection settings.
  - `ws`: The OpAMP websocket transport settings.
    - `tls`: TLS settings.
    - `headers`: HTTP headers to set.
    - `auth`: The ID of an auth extension to use for authentication.

The following settings are optional for the HTTP client:

- `server`: The OpAMP server connection settings.
  - `http`: The OpAMP websocket transport settings.
    - `tls`: TLS settings.
    - `headers`: HTTP headers to set.
    - `polling_interval`: The interval at which the extension will poll the server. Defaults to 30s.
    - `auth`: The ID of an auth extension to use for authentication.

The following settings are optional for both transports:

- `instance_uid`: A UUIDv7 formatted as a 36 character string in canonical
  representation. Auto-generated on start if missing. Setting this ensures the
  instance UID remains constant across process restarts.
- `capabilities`: Keys with boolean true/false values that enable a particular OpAMP capability.
  - `reports_effective_config`: Whether to enable the OpAMP ReportsEffectiveConfig capability. Default is `true`.
  - `reports_health`: Whether to enable the OpAMP ReportsHealth capability. Default is `true`.
- `agent_description`: Setting that modifies the agent description reported to the OpAMP server.
  - `non_identifying_attributes`: A map of key value pairs that will be added to the [non-identifying attributes](https://github.com/open-telemetry/opamp-spec/blob/main/specification.md#agentdescriptionnon_identifying_attributes) reported to the OpAMP server. If an attribute collides with the default non-identifying attributes that are automatically added, the ones specified here take precedence.
- `ppid`: An optional process ID to monitor. When this process is no longer running, the extension will emit a fatal error, causing the collector to exit. This is meant to be set by the Supervisor or some other parent process, and should not be configured manually.
- `ppid_poll_interval`: The poll interval between check for whether `ppid` is still alive or not. Defaults to 5 seconds.

### Example

``` yaml
extensions:
  opamp:
    server:
      ws:
        endpoint: wss://127.0.0.1:4320/v1/opamp
```

## Custom Messages

Other components may use a configured OpAMP extension to send and receive custom messages to and from an OpAMP server.

See the [opampcustommessages](../opampcustommessages/README.md) module for more information on the custom message API.

## Status

This OpenTelemetry OpAMP agent extension is intended to support the [OpAMP
Supervisor][supervisor].

[supervisor]: https://github.com/open-telemetry/opentelemetry-collector-contrib/tree/main/cmd/opampsupervisor
