[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# k8sattributes

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| container.id | Container ID. Usually a UUID, as for example used to identify Docker containers. The UUID might be abbreviated. Requires k8s.container.restart_count. | Any Str | false |
| container.image.name | Name of the image the container was built on. Requires container.id or k8s.container.name. | Any Str | true |
| container.image.repo_digests | Repo digests of the container image as provided by the container runtime. | Any Slice | false |
| container.image.tag | Container image tag. Defaults to "latest" if not provided (unless digest also in image path) Requires container.id or k8s.container.name. | Any Str | true |
| k8s.cluster.uid | Gives cluster uid identified with kube-system namespace | Any Str | false |
| k8s.container.name | The name of the Container in a Pod template. Requires container.id. | Any Str | false |
| k8s.cronjob.name | The name of the CronJob. | Any Str | false |
| k8s.daemonset.name | The name of the DaemonSet. | Any Str | false |
| k8s.daemonset.uid | The UID of the DaemonSet. | Any Str | false |
| k8s.deployment.name | The name of the Deployment. | Any Str | true |
| k8s.deployment.uid | The UID of the Deployment. | Any Str | false |
| k8s.job.name | The name of the Job. | Any Str | false |
| k8s.job.uid | The UID of the Job. | Any Str | false |
| k8s.namespace.name | The name of the namespace that the pod is running in. | Any Str | true |
| k8s.node.name | The name of the Node. | Any Str | true |
| k8s.node.uid | The UID of the Node. | Any Str | false |
| k8s.pod.hostname | The hostname of the Pod. | Any Str | false |
| k8s.pod.ip | The IP address of the Pod. | Any Str | false |
| k8s.pod.name | The name of the Pod. | Any Str | true |
| k8s.pod.start_time | The start time of the Pod. | Any Str | true |
| k8s.pod.uid | The UID of the Pod. | Any Str | true |
| k8s.replicaset.name | The name of the ReplicaSet. | Any Str | false |
| k8s.replicaset.uid | The UID of the ReplicaSet. | Any Str | false |
| k8s.statefulset.name | The name of the StatefulSet. | Any Str | false |
| k8s.statefulset.uid | The UID of the StatefulSet. | Any Str | false |

## Internal Telemetry

The following telemetry is emitted by this component.

### otelcol_otelsvc_k8s_ip_lookup_miss

Number of times pod by IP lookup failed.

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_namespace_added

Number of namespace add events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_namespace_deleted

Number of namespace delete events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_namespace_updated

Number of namespace update events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_node_added

Number of node add events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_node_deleted

Number of node delete events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_node_updated

Number of node update events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_pod_added

Number of pod add events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_pod_deleted

Number of pod delete events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_pod_table_size

Size of table containing pod info

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

### otelcol_otelsvc_k8s_pod_updated

Number of pod update events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_replicaset_added

Number of ReplicaSet add events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_replicaset_deleted

Number of ReplicaSet delete events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_otelsvc_k8s_replicaset_updated

Number of ReplicaSet update events received

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |
