// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestResourceBuilder(t *testing.T) {
	for _, tt := range []string{"default", "all_set", "none_set"} {
		t.Run(tt, func(t *testing.T) {
			cfg := loadResourceAttributesConfig(t, tt)
			rb := NewResourceBuilder(cfg)
			rb.SetAwsEcsClusterArn("aws.ecs.cluster.arn-val")
			rb.SetAwsEcsLaunchtype("aws.ecs.launchtype-val")
			rb.SetAwsEcsTaskArn("aws.ecs.task.arn-val")
			rb.SetAwsEcsTaskFamily("aws.ecs.task.family-val")
			rb.SetAwsEcsTaskID("aws.ecs.task.id-val")
			rb.SetAwsEcsTaskRevision("aws.ecs.task.revision-val")
			rb.SetAwsLogGroupArns([]any{"aws.log.group.arns-item1", "aws.log.group.arns-item2"})
			rb.SetAwsLogGroupNames([]any{"aws.log.group.names-item1", "aws.log.group.names-item2"})
			rb.SetAwsLogStreamArns([]any{"aws.log.stream.arns-item1", "aws.log.stream.arns-item2"})
			rb.SetAwsLogStreamNames([]any{"aws.log.stream.names-item1", "aws.log.stream.names-item2"})
			rb.SetCloudAccountID("cloud.account.id-val")
			rb.SetCloudAvailabilityZone("cloud.availability_zone-val")
			rb.SetCloudPlatform("cloud.platform-val")
			rb.SetCloudProvider("cloud.provider-val")
			rb.SetCloudRegion("cloud.region-val")

			res := rb.Emit()
			assert.Equal(t, 0, rb.Emit().Attributes().Len()) // Second call should return empty Resource

			switch tt {
			case "default":
				assert.Equal(t, 15, res.Attributes().Len())
			case "all_set":
				assert.Equal(t, 15, res.Attributes().Len())
			case "none_set":
				assert.Equal(t, 0, res.Attributes().Len())
				return
			default:
				assert.Failf(t, "unexpected test case: %s", tt)
			}

			val, ok := res.Attributes().Get("aws.ecs.cluster.arn")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "aws.ecs.cluster.arn-val", val.Str())
			}
			val, ok = res.Attributes().Get("aws.ecs.launchtype")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "aws.ecs.launchtype-val", val.Str())
			}
			val, ok = res.Attributes().Get("aws.ecs.task.arn")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "aws.ecs.task.arn-val", val.Str())
			}
			val, ok = res.Attributes().Get("aws.ecs.task.family")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "aws.ecs.task.family-val", val.Str())
			}
			val, ok = res.Attributes().Get("aws.ecs.task.id")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "aws.ecs.task.id-val", val.Str())
			}
			val, ok = res.Attributes().Get("aws.ecs.task.revision")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "aws.ecs.task.revision-val", val.Str())
			}
			val, ok = res.Attributes().Get("aws.log.group.arns")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, []any{"aws.log.group.arns-item1", "aws.log.group.arns-item2"}, val.Slice().AsRaw())
			}
			val, ok = res.Attributes().Get("aws.log.group.names")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, []any{"aws.log.group.names-item1", "aws.log.group.names-item2"}, val.Slice().AsRaw())
			}
			val, ok = res.Attributes().Get("aws.log.stream.arns")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, []any{"aws.log.stream.arns-item1", "aws.log.stream.arns-item2"}, val.Slice().AsRaw())
			}
			val, ok = res.Attributes().Get("aws.log.stream.names")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, []any{"aws.log.stream.names-item1", "aws.log.stream.names-item2"}, val.Slice().AsRaw())
			}
			val, ok = res.Attributes().Get("cloud.account.id")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "cloud.account.id-val", val.Str())
			}
			val, ok = res.Attributes().Get("cloud.availability_zone")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "cloud.availability_zone-val", val.Str())
			}
			val, ok = res.Attributes().Get("cloud.platform")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "cloud.platform-val", val.Str())
			}
			val, ok = res.Attributes().Get("cloud.provider")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "cloud.provider-val", val.Str())
			}
			val, ok = res.Attributes().Get("cloud.region")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "cloud.region-val", val.Str())
			}
		})
	}
}
