// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestResourceBuilder(t *testing.T) {
	for _, tt := range []string{"default", "all_set", "none_set"} {
		t.Run(tt, func(t *testing.T) {
			cfg := loadResourceAttributesConfig(t, tt)
			rb := NewResourceBuilder(cfg)
			rb.SetAwsLogGroupNames([]any{"aws.log.group.names-item1", "aws.log.group.names-item2"})
			rb.SetAwsLogStreamNames([]any{"aws.log.stream.names-item1", "aws.log.stream.names-item2"})
			rb.SetCloudPlatform("cloud.platform-val")
			rb.SetCloudProvider("cloud.provider-val")
			rb.SetCloudRegion("cloud.region-val")
			rb.SetFaasInstance("faas.instance-val")
			rb.SetFaasMaxMemory("faas.max_memory-val")
			rb.SetFaasName("faas.name-val")
			rb.SetFaasVersion("faas.version-val")

			res := rb.Emit()
			assert.Equal(t, 0, rb.Emit().Attributes().Len()) // Second call should return empty Resource

			switch tt {
			case "default":
				assert.Equal(t, 9, res.Attributes().Len())
			case "all_set":
				assert.Equal(t, 9, res.Attributes().Len())
			case "none_set":
				assert.Equal(t, 0, res.Attributes().Len())
				return
			default:
				assert.Failf(t, "unexpected test case: %s", tt)
			}

			val, ok := res.Attributes().Get("aws.log.group.names")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, []any{"aws.log.group.names-item1", "aws.log.group.names-item2"}, val.Slice().AsRaw())
			}
			val, ok = res.Attributes().Get("aws.log.stream.names")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, []any{"aws.log.stream.names-item1", "aws.log.stream.names-item2"}, val.Slice().AsRaw())
			}
			val, ok = res.Attributes().Get("cloud.platform")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "cloud.platform-val", val.Str())
			}
			val, ok = res.Attributes().Get("cloud.provider")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "cloud.provider-val", val.Str())
			}
			val, ok = res.Attributes().Get("cloud.region")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "cloud.region-val", val.Str())
			}
			val, ok = res.Attributes().Get("faas.instance")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "faas.instance-val", val.Str())
			}
			val, ok = res.Attributes().Get("faas.max_memory")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "faas.max_memory-val", val.Str())
			}
			val, ok = res.Attributes().Get("faas.name")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "faas.name-val", val.Str())
			}
			val, ok = res.Attributes().Get("faas.version")
			assert.True(t, ok)
			if ok {
				assert.EqualValues(t, "faas.version-val", val.Str())
			}
		})
	}
}
