// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"go.opentelemetry.io/collector/confmap"
)

// MetricConfig provides common config for a particular metric.
type MetricConfig struct {
	Enabled bool `mapstructure:"enabled"`

	enabledSetByUser bool
}

func (ms *MetricConfig) Unmarshal(parser *confmap.Conf) error {
	if parser == nil {
		return nil
	}
	err := parser.Unmarshal(ms)
	if err != nil {
		return err
	}
	ms.enabledSetByUser = parser.IsSet("enabled")
	return nil
}

// MetricsConfig provides config for active_directory_ds metrics.
type MetricsConfig struct {
	ActiveDirectoryDsBindRate                                  MetricConfig `mapstructure:"active_directory.ds.bind.rate"`
	ActiveDirectoryDsLdapBindLastSuccessfulTime                MetricConfig `mapstructure:"active_directory.ds.ldap.bind.last_successful.time"`
	ActiveDirectoryDsLdapBindRate                              MetricConfig `mapstructure:"active_directory.ds.ldap.bind.rate"`
	ActiveDirectoryDsLdapClientSessionCount                    MetricConfig `mapstructure:"active_directory.ds.ldap.client.session.count"`
	ActiveDirectoryDsLdapSearchRate                            MetricConfig `mapstructure:"active_directory.ds.ldap.search.rate"`
	ActiveDirectoryDsNameCacheHitRate                          MetricConfig `mapstructure:"active_directory.ds.name_cache.hit_rate"`
	ActiveDirectoryDsNotificationQueued                        MetricConfig `mapstructure:"active_directory.ds.notification.queued"`
	ActiveDirectoryDsOperationRate                             MetricConfig `mapstructure:"active_directory.ds.operation.rate"`
	ActiveDirectoryDsReplicationNetworkIo                      MetricConfig `mapstructure:"active_directory.ds.replication.network.io"`
	ActiveDirectoryDsReplicationObjectRate                     MetricConfig `mapstructure:"active_directory.ds.replication.object.rate"`
	ActiveDirectoryDsReplicationOperationPending               MetricConfig `mapstructure:"active_directory.ds.replication.operation.pending"`
	ActiveDirectoryDsReplicationPropertyRate                   MetricConfig `mapstructure:"active_directory.ds.replication.property.rate"`
	ActiveDirectoryDsReplicationSyncObjectPending              MetricConfig `mapstructure:"active_directory.ds.replication.sync.object.pending"`
	ActiveDirectoryDsReplicationSyncRequestCount               MetricConfig `mapstructure:"active_directory.ds.replication.sync.request.count"`
	ActiveDirectoryDsReplicationValueRate                      MetricConfig `mapstructure:"active_directory.ds.replication.value.rate"`
	ActiveDirectoryDsSecurityDescriptorPropagationsEventQueued MetricConfig `mapstructure:"active_directory.ds.security_descriptor_propagations_event.queued"`
	ActiveDirectoryDsSuboperationRate                          MetricConfig `mapstructure:"active_directory.ds.suboperation.rate"`
	ActiveDirectoryDsThreadCount                               MetricConfig `mapstructure:"active_directory.ds.thread.count"`
}

func DefaultMetricsConfig() MetricsConfig {
	return MetricsConfig{
		ActiveDirectoryDsBindRate: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsLdapBindLastSuccessfulTime: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsLdapBindRate: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsLdapClientSessionCount: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsLdapSearchRate: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsNameCacheHitRate: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsNotificationQueued: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsOperationRate: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsReplicationNetworkIo: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsReplicationObjectRate: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsReplicationOperationPending: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsReplicationPropertyRate: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsReplicationSyncObjectPending: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsReplicationSyncRequestCount: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsReplicationValueRate: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsSecurityDescriptorPropagationsEventQueued: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsSuboperationRate: MetricConfig{
			Enabled: true,
		},
		ActiveDirectoryDsThreadCount: MetricConfig{
			Enabled: true,
		},
	}
}

// MetricsBuilderConfig is a configuration for active_directory_ds metrics builder.
type MetricsBuilderConfig struct {
	Metrics MetricsConfig `mapstructure:"metrics"`
}

func DefaultMetricsBuilderConfig() MetricsBuilderConfig {
	return MetricsBuilderConfig{
		Metrics: DefaultMetricsConfig(),
	}
}
