// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"path/filepath"
	"testing"

	"github.com/google/go-cmp/cmp"
	"github.com/google/go-cmp/cmp/cmpopts"
	"github.com/stretchr/testify/require"
	"go.opentelemetry.io/collector/confmap/confmaptest"
)

func TestMetricsBuilderConfig(t *testing.T) {
	tests := []struct {
		name string
		want MetricsBuilderConfig
	}{
		{
			name: "default",
			want: DefaultMetricsBuilderConfig(),
		},
		{
			name: "all_set",
			want: MetricsBuilderConfig{
				Metrics: MetricsConfig{
					ActiveDirectoryDsBindRate:                                  MetricConfig{Enabled: true},
					ActiveDirectoryDsLdapBindLastSuccessfulTime:                MetricConfig{Enabled: true},
					ActiveDirectoryDsLdapBindRate:                              MetricConfig{Enabled: true},
					ActiveDirectoryDsLdapClientSessionCount:                    MetricConfig{Enabled: true},
					ActiveDirectoryDsLdapSearchRate:                            MetricConfig{Enabled: true},
					ActiveDirectoryDsNameCacheHitRate:                          MetricConfig{Enabled: true},
					ActiveDirectoryDsNotificationQueued:                        MetricConfig{Enabled: true},
					ActiveDirectoryDsOperationRate:                             MetricConfig{Enabled: true},
					ActiveDirectoryDsReplicationNetworkIo:                      MetricConfig{Enabled: true},
					ActiveDirectoryDsReplicationObjectRate:                     MetricConfig{Enabled: true},
					ActiveDirectoryDsReplicationOperationPending:               MetricConfig{Enabled: true},
					ActiveDirectoryDsReplicationPropertyRate:                   MetricConfig{Enabled: true},
					ActiveDirectoryDsReplicationSyncObjectPending:              MetricConfig{Enabled: true},
					ActiveDirectoryDsReplicationSyncRequestCount:               MetricConfig{Enabled: true},
					ActiveDirectoryDsReplicationValueRate:                      MetricConfig{Enabled: true},
					ActiveDirectoryDsSecurityDescriptorPropagationsEventQueued: MetricConfig{Enabled: true},
					ActiveDirectoryDsSuboperationRate:                          MetricConfig{Enabled: true},
					ActiveDirectoryDsThreadCount:                               MetricConfig{Enabled: true},
				},
			},
		},
		{
			name: "none_set",
			want: MetricsBuilderConfig{
				Metrics: MetricsConfig{
					ActiveDirectoryDsBindRate:                                  MetricConfig{Enabled: false},
					ActiveDirectoryDsLdapBindLastSuccessfulTime:                MetricConfig{Enabled: false},
					ActiveDirectoryDsLdapBindRate:                              MetricConfig{Enabled: false},
					ActiveDirectoryDsLdapClientSessionCount:                    MetricConfig{Enabled: false},
					ActiveDirectoryDsLdapSearchRate:                            MetricConfig{Enabled: false},
					ActiveDirectoryDsNameCacheHitRate:                          MetricConfig{Enabled: false},
					ActiveDirectoryDsNotificationQueued:                        MetricConfig{Enabled: false},
					ActiveDirectoryDsOperationRate:                             MetricConfig{Enabled: false},
					ActiveDirectoryDsReplicationNetworkIo:                      MetricConfig{Enabled: false},
					ActiveDirectoryDsReplicationObjectRate:                     MetricConfig{Enabled: false},
					ActiveDirectoryDsReplicationOperationPending:               MetricConfig{Enabled: false},
					ActiveDirectoryDsReplicationPropertyRate:                   MetricConfig{Enabled: false},
					ActiveDirectoryDsReplicationSyncObjectPending:              MetricConfig{Enabled: false},
					ActiveDirectoryDsReplicationSyncRequestCount:               MetricConfig{Enabled: false},
					ActiveDirectoryDsReplicationValueRate:                      MetricConfig{Enabled: false},
					ActiveDirectoryDsSecurityDescriptorPropagationsEventQueued: MetricConfig{Enabled: false},
					ActiveDirectoryDsSuboperationRate:                          MetricConfig{Enabled: false},
					ActiveDirectoryDsThreadCount:                               MetricConfig{Enabled: false},
				},
			},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			cfg := loadMetricsBuilderConfig(t, tt.name)
			diff := cmp.Diff(tt.want, cfg, cmpopts.IgnoreUnexported(MetricConfig{}))
			require.Emptyf(t, diff, "Config mismatch (-expected +actual):\n%s", diff)
		})
	}
}

func loadMetricsBuilderConfig(t *testing.T, name string) MetricsBuilderConfig {
	cm, err := confmaptest.LoadConf(filepath.Join("testdata", "config.yaml"))
	require.NoError(t, err)
	sub, err := cm.Sub(name)
	require.NoError(t, err)
	cfg := DefaultMetricsBuilderConfig()
	require.NoError(t, sub.Unmarshal(&cfg))
	return cfg
}
