[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# aerospike

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### aerospike.namespace.disk.available

Minimum percentage of contiguous disk space free to the namespace across all devices

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| % | Gauge | Int |

### aerospike.namespace.geojson.region_query_cells

Number of cell coverings for query region queried

Number of cell coverings for query region queried. Aerospike metric geo_region_query_cells.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {cells} | Sum | Int | Cumulative | true |

### aerospike.namespace.geojson.region_query_false_positive

Number of points outside the region.

Total query result points is geo_region_query_points + geo_region_query_falsepos. Aerospike metric geo_regio_query_falspos.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {points} | Sum | Int | Cumulative | true |

### aerospike.namespace.geojson.region_query_points

Number of points within the region.

Total query result points is geo_region_query_points + geo_region_query_falsepos. Aerospike metric geo_region_query_points.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {points} | Sum | Int | Cumulative | true |

### aerospike.namespace.geojson.region_query_requests

Number of geojson queries on the system since the uptime of the node.

Number of geojson queries on the system since the uptime of the node. Aerospike metric geo_region_query_reqs.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {queries} | Sum | Int | Cumulative | true |

### aerospike.namespace.memory.free

Percentage of the namespace's memory which is still free

Aerospike metric memory_free_pct

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| % | Gauge | Int |

### aerospike.namespace.memory.usage

Memory currently used by each component of the namespace

Aggregate of Aerospike Metrics memory_used_data_bytes, memory_used_index_bytes, memory_used_set_index_bytes, memory_used_sindex_bytes

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| component | Individual component of a namespace | Str: ``data``, ``index``, ``set_index``, ``secondary_index`` |

### aerospike.namespace.query.count

Number of query operations performed on the namespace

Aggregate of Aerospike Metrics query_aggr_abort, query_aggr_complete, query_aggr_error, query_basic_abort, query_basic_complete, query_basic_error, query_ops_bg_abort, query_ops_bg_complete, query_ops_bg_error, query_udf_bg_abort, query_udf_bg_complete, query_udf_bg_error, pi_query_aggr_abort, pi_query_aggr_complete, pi_query_aggr_error, pi_query_long_basic_abort, pi_query_long_basic_complete, pi_query_long_basic_error, pi_query_ops_bg_abort, pi_query_ops_bg_basic_complete, pi_query_ops_bg_basic_error, pi_query_short_basic_timeout, pi_query_short_basic_complete, pi_query_short_basic_error, pi_query_udf_bg_abort, pi_query_udf_bg_complete, pi_query_udf_bg_error, si_query_aggr_abort, si_query_aggr_complete, si_query_aggr_error, si_query_long_basic_abort, si_query_long_basic_complete, si_query_long_basic_error, si_query_ops_bg_abort, si_query_ops_bg_basic_complete, si_query_ops_bg_basic_error, si_query_short_basic_timeout, si_query_short_basic_complete, si_query_short_basic_error, si_query_udf_bg_abort, si_query_udf_bg_complete, si_query_udf_bg_error

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {queries} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | Type of query operation performed on a namespace | Str: ``aggregation``, ``basic``, ``short``, ``long_basic``, ``short_basic``, ``ops_background``, ``udf_background`` |
| index | Type of index the operation was performed on | Str: ``primary``, ``secondary`` |
| result | Result of a query operation performed on a namespace | Str: ``abort``, ``complete``, ``error``, ``timeout`` |

### aerospike.namespace.scan.count

Number of scan operations performed on the namespace

Aggregate of Aerospike Metrics scan_aggr_abort, scan_aggr_complete, scan_aggr_error, scan_basic_abort, scan_basic_complete, scan_basic_error, scan_ops_bg_abort, scan_ops_bg_complete, scan_ops_bg_error, scan_udf_bg_abort, scan_udf_bg_complete, scan_udf_bg_error

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {scans} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | Type of scan operation performed on a namespace | Str: ``aggregation``, ``basic``, ``ops_background``, ``udf_background`` |
| result | Result of a scan operation performed on a namespace | Str: ``abort``, ``complete``, ``error`` |

### aerospike.namespace.transaction.count

Number of transactions performed on the namespace

Aggregate of Aerospike Metrics client_delete_error, client_delete_filtered_out, client_delete_not_found, client_delete_success, client_delete_timeout, client_read_error, client_read_filtered_out, client_read_not_found, client_read_success, client_read_timeout, client_udf_error, client_udf_filtered_out, client_udf_not_found, client_udf_success, client_udf_timeout, client_write_error, client_write_filtered_out, client_write_not_found, client_write_success, client_write_timeout

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {transactions} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | Type of transaction performed on a namespace | Str: ``delete``, ``read``, ``udf``, ``write`` |
| result | Result of a transaction performed on a namespace | Str: ``error``, ``filtered_out``, ``not_found``, ``success``, ``timeout`` |

### aerospike.node.connection.count

Number of connections opened and closed to the node

Aggregate of Aerospike Metrics client_connections_closed, client_connections_opened, fabric_connections_closed, fabric_connections_opened, heartbeat_connections_closed, heartbeat_connections_opened

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | Type of connection to an Aerospike node | Str: ``client``, ``fabric``, ``heartbeat`` |
| operation | Operation performed with a connection (open or close) | Str: ``close``, ``open`` |

### aerospike.node.connection.open

Current number of open connections to the node

Aggregate of Aerospike Metrics client_connections, fabric_connections, heartbeat_connections

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | Type of connection to an Aerospike node | Str: ``client``, ``fabric``, ``heartbeat`` |

### aerospike.node.memory.free

Percentage of the node's memory which is still free

Aerospike Metric system_free_mem_pct

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| % | Gauge | Int |

### aerospike.node.query.tracked

Number of queries tracked by the system.

Number of queries which ran more than query untracked_time (default 1 sec), Aerospike metric query_tracked

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {queries} | Sum | Int | Cumulative | true |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| aerospike.namespace | Name of the Aerospike namespace | Any Str | true |
| aerospike.node.name | Name of the Aerospike node collected from | Any Str | true |
