// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"path/filepath"
	"testing"

	"github.com/google/go-cmp/cmp"
	"github.com/google/go-cmp/cmp/cmpopts"
	"github.com/stretchr/testify/require"
	"go.opentelemetry.io/collector/confmap/confmaptest"
)

func TestMetricsBuilderConfig(t *testing.T) {
	tests := []struct {
		name string
		want MetricsBuilderConfig
	}{
		{
			name: "default",
			want: DefaultMetricsBuilderConfig(),
		},
		{
			name: "all_set",
			want: MetricsBuilderConfig{
				Metrics: MetricsConfig{
					AerospikeNamespaceDiskAvailable:                   MetricConfig{Enabled: true},
					AerospikeNamespaceGeojsonRegionQueryCells:         MetricConfig{Enabled: true},
					AerospikeNamespaceGeojsonRegionQueryFalsePositive: MetricConfig{Enabled: true},
					AerospikeNamespaceGeojsonRegionQueryPoints:        MetricConfig{Enabled: true},
					AerospikeNamespaceGeojsonRegionQueryRequests:      MetricConfig{Enabled: true},
					AerospikeNamespaceMemoryFree:                      MetricConfig{Enabled: true},
					AerospikeNamespaceMemoryUsage:                     MetricConfig{Enabled: true},
					AerospikeNamespaceQueryCount:                      MetricConfig{Enabled: true},
					AerospikeNamespaceScanCount:                       MetricConfig{Enabled: true},
					AerospikeNamespaceTransactionCount:                MetricConfig{Enabled: true},
					AerospikeNodeConnectionCount:                      MetricConfig{Enabled: true},
					AerospikeNodeConnectionOpen:                       MetricConfig{Enabled: true},
					AerospikeNodeMemoryFree:                           MetricConfig{Enabled: true},
					AerospikeNodeQueryTracked:                         MetricConfig{Enabled: true},
				},
				ResourceAttributes: ResourceAttributesConfig{
					AerospikeNamespace: ResourceAttributeConfig{Enabled: true},
					AerospikeNodeName:  ResourceAttributeConfig{Enabled: true},
				},
			},
		},
		{
			name: "none_set",
			want: MetricsBuilderConfig{
				Metrics: MetricsConfig{
					AerospikeNamespaceDiskAvailable:                   MetricConfig{Enabled: false},
					AerospikeNamespaceGeojsonRegionQueryCells:         MetricConfig{Enabled: false},
					AerospikeNamespaceGeojsonRegionQueryFalsePositive: MetricConfig{Enabled: false},
					AerospikeNamespaceGeojsonRegionQueryPoints:        MetricConfig{Enabled: false},
					AerospikeNamespaceGeojsonRegionQueryRequests:      MetricConfig{Enabled: false},
					AerospikeNamespaceMemoryFree:                      MetricConfig{Enabled: false},
					AerospikeNamespaceMemoryUsage:                     MetricConfig{Enabled: false},
					AerospikeNamespaceQueryCount:                      MetricConfig{Enabled: false},
					AerospikeNamespaceScanCount:                       MetricConfig{Enabled: false},
					AerospikeNamespaceTransactionCount:                MetricConfig{Enabled: false},
					AerospikeNodeConnectionCount:                      MetricConfig{Enabled: false},
					AerospikeNodeConnectionOpen:                       MetricConfig{Enabled: false},
					AerospikeNodeMemoryFree:                           MetricConfig{Enabled: false},
					AerospikeNodeQueryTracked:                         MetricConfig{Enabled: false},
				},
				ResourceAttributes: ResourceAttributesConfig{
					AerospikeNamespace: ResourceAttributeConfig{Enabled: false},
					AerospikeNodeName:  ResourceAttributeConfig{Enabled: false},
				},
			},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			cfg := loadMetricsBuilderConfig(t, tt.name)
			diff := cmp.Diff(tt.want, cfg, cmpopts.IgnoreUnexported(MetricConfig{}, ResourceAttributeConfig{}))
			require.Emptyf(t, diff, "Config mismatch (-expected +actual):\n%s", diff)
		})
	}
}

func loadMetricsBuilderConfig(t *testing.T, name string) MetricsBuilderConfig {
	cm, err := confmaptest.LoadConf(filepath.Join("testdata", "config.yaml"))
	require.NoError(t, err)
	sub, err := cm.Sub(name)
	require.NoError(t, err)
	cfg := DefaultMetricsBuilderConfig()
	require.NoError(t, sub.Unmarshal(&cfg))
	return cfg
}

func TestResourceAttributesConfig(t *testing.T) {
	tests := []struct {
		name string
		want ResourceAttributesConfig
	}{
		{
			name: "default",
			want: DefaultResourceAttributesConfig(),
		},
		{
			name: "all_set",
			want: ResourceAttributesConfig{
				AerospikeNamespace: ResourceAttributeConfig{Enabled: true},
				AerospikeNodeName:  ResourceAttributeConfig{Enabled: true},
			},
		},
		{
			name: "none_set",
			want: ResourceAttributesConfig{
				AerospikeNamespace: ResourceAttributeConfig{Enabled: false},
				AerospikeNodeName:  ResourceAttributeConfig{Enabled: false},
			},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			cfg := loadResourceAttributesConfig(t, tt.name)
			diff := cmp.Diff(tt.want, cfg, cmpopts.IgnoreUnexported(ResourceAttributeConfig{}))
			require.Emptyf(t, diff, "Config mismatch (-expected +actual):\n%s", diff)
		})
	}
}

func loadResourceAttributesConfig(t *testing.T, name string) ResourceAttributesConfig {
	cm, err := confmaptest.LoadConf(filepath.Join("testdata", "config.yaml"))
	require.NoError(t, err)
	sub, err := cm.Sub(name)
	require.NoError(t, err)
	sub, err = sub.Sub("resource_attributes")
	require.NoError(t, err)
	cfg := DefaultResourceAttributesConfig()
	require.NoError(t, sub.Unmarshal(&cfg))
	return cfg
}
