[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# chrony

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### ntp.skew

This is the estimated error bound on the frequency.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ppm | Gauge | Double |

### ntp.time.correction

The number of seconds difference between the system's clock and the reference clock

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| seconds | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| leap.status | how the chrony is handling leap seconds | Str: ``normal``, ``insert_second``, ``delete_second``, ``unsynchronised`` |

### ntp.time.last_offset

The estimated local offset on the last clock update

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| seconds | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| leap.status | how the chrony is handling leap seconds | Str: ``normal``, ``insert_second``, ``delete_second``, ``unsynchronised`` |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### ntp.frequency.offset

The frequency is the rate by which the system s clock would be wrong if chronyd was not correcting it.

It is expressed in ppm (parts per million). For example, a value of 1 ppm would mean that when the system’s clock thinks it has advanced 1 second, it has actually advanced by 1.000001 seconds relative to true time.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ppm | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| leap.status | how the chrony is handling leap seconds | Str: ``normal``, ``insert_second``, ``delete_second``, ``unsynchronised`` |

### ntp.stratum

The number of hops away from the reference system keeping the reference time

To read further, refer to https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/7/html/system_administrators_guide/ch-configuring_ntp_using_the_chrony_suite#sect-Checking_chrony_tracking

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {count} | Gauge | Int |

### ntp.time.rms_offset

the long term average of the offset value

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| seconds | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| leap.status | how the chrony is handling leap seconds | Str: ``normal``, ``insert_second``, ``delete_second``, ``unsynchronised`` |

### ntp.time.root_delay

This is the total of the network path delays to the stratum-1 system from which the system is ultimately synchronised.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| seconds | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| leap.status | how the chrony is handling leap seconds | Str: ``normal``, ``insert_second``, ``delete_second``, ``unsynchronised`` |
