[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# expvar

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### process.runtime.memstats.buck_hash_sys

Bytes of memory in profiling bucket hash tables.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.frees

Cumulative count of heap objects freed.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {objects} | Sum | Int | Cumulative | true |

### process.runtime.memstats.gc_cpu_fraction

The fraction of this program's available CPU time used by the GC since the program started.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

### process.runtime.memstats.gc_sys

Bytes of memory in garbage collection metadata.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.heap_alloc

Bytes of allocated heap objects.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.heap_idle

Bytes in idle (unused) spans.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.heap_inuse

Bytes in in-use spans.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.heap_objects

Number of allocated heap objects.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {objects} | Sum | Int | Cumulative | false |

### process.runtime.memstats.heap_released

Bytes of physical memory returned to the OS.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.heap_sys

Bytes of heap memory obtained by the OS.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.last_pause

The most recent stop-the-world pause time.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ns | Gauge | Int |

### process.runtime.memstats.mallocs

Cumulative count of heap objects allocated.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {objects} | Sum | Int | Cumulative | true |

### process.runtime.memstats.mcache_inuse

Bytes of allocated mcache structures.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.mcache_sys

Bytes of memory obtained from the OS for mcache structures.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.mspan_inuse

Bytes of allocated mspan structures.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.mspan_sys

Bytes of memory obtained from the OS for mspan structures.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.next_gc

The target heap size of the next GC cycle.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.num_forced_gc

Number of GC cycles that were forced by the application calling the GC function.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | true |

### process.runtime.memstats.num_gc

Number of completed GC cycles.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | true |

### process.runtime.memstats.other_sys

Bytes of memory in miscellaneous off-heap runtime allocations.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.pause_total

The cumulative nanoseconds in GC stop-the-world pauses since the program started.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | true |

### process.runtime.memstats.stack_inuse

Bytes in stack spans.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.stack_sys

Bytes of stack memory obtained from the OS.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### process.runtime.memstats.sys

Total bytes of memory obtained from the OS.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### process.runtime.memstats.lookups

Number of pointer lookups performed by the runtime.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {lookups} | Sum | Int | Cumulative | false |

### process.runtime.memstats.total_alloc

Cumulative bytes allocated for heap objects.

As defined by https://pkg.go.dev/runtime#MemStats

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | true |
