[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# flinkmetrics

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### flink.job.checkpoint.count

The number of checkpoints completed or failed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {checkpoints} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| checkpoint | The number of checkpoints completed or that failed. | Str: ``completed``, ``failed`` |

### flink.job.checkpoint.in_progress

The number of checkpoints in progress.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {checkpoints} | Sum | Int | Cumulative | false |

### flink.job.last_checkpoint.size

The total size of the last checkpoint.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.job.last_checkpoint.time

The end to end duration of the last checkpoint.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ms | Gauge | Int |

### flink.job.restart.count

The total number of restarts since this job was submitted, including full restarts and fine-grained restarts.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {restarts} | Sum | Int | Cumulative | true |

### flink.jvm.class_loader.classes_loaded

The total number of classes loaded since the start of the JVM.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {classes} | Sum | Int | Cumulative | true |

### flink.jvm.cpu.load

The CPU usage of the JVM for a jobmanager or taskmanager.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| % | Gauge | Double |

### flink.jvm.cpu.time

The CPU time used by the JVM for a jobmanager or taskmanager.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| ns | Sum | Int | Cumulative | true |

### flink.jvm.gc.collections.count

The total number of collections that have occurred.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {collections} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| name | The names for the parallel scavenge and garbage first garbage collectors. | Str: ``PS_MarkSweep``, ``PS_Scavenge``, ``G1_Young_Generation``, ``G1_Old_Generation`` |

### flink.jvm.gc.collections.time

The total time spent performing garbage collection.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| ms | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| name | The names for the parallel scavenge and garbage first garbage collectors. | Str: ``PS_MarkSweep``, ``PS_Scavenge``, ``G1_Young_Generation``, ``G1_Old_Generation`` |

### flink.jvm.memory.direct.total_capacity

The total capacity of all buffers in the direct buffer pool.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.direct.used

The amount of memory used by the JVM for the direct buffer pool.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.heap.committed

The amount of heap memory guaranteed to be available to the JVM.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.heap.max

The maximum amount of heap memory that can be used for memory management.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.heap.used

The amount of heap memory currently used.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.mapped.total_capacity

The number of buffers in the mapped buffer pool.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.mapped.used

The amount of memory used by the JVM for the mapped buffer pool.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.metaspace.committed

The amount of memory guaranteed to be available to the JVM in the Metaspace memory pool.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.metaspace.max

The maximum amount of memory that can be used in the Metaspace memory pool.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.metaspace.used

The amount of memory currently used in the Metaspace memory pool.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.nonheap.committed

The amount of non-heap memory guaranteed to be available to the JVM.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.nonheap.max

The maximum amount of non-heap memory that can be used for memory management.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.memory.nonheap.used

The amount of non-heap memory currently used.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.jvm.threads.count

The total number of live threads.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {threads} | Sum | Int | Cumulative | false |

### flink.memory.managed.total

The total amount of managed memory.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.memory.managed.used

The amount of managed memory currently used.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### flink.operator.record.count

The number of records an operator has.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {records} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| name | The operator name. | Any Str |
| record | The number of records received in, sent out or dropped due to arriving late. | Str: ``in``, ``out``, ``dropped`` |

### flink.operator.watermark.output

The last watermark this operator has emitted.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| ms | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| name | The operator name. | Any Str |

### flink.task.record.count

The number of records a task has.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {records} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| record | The number of records received in, sent out or dropped due to arriving late. | Str: ``in``, ``out``, ``dropped`` |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| flink.job.name | The job name. | Any Str | true |
| flink.resource.type | The flink scope type in which a metric belongs to. | Str: ``jobmanager``, ``taskmanager`` | true |
| flink.subtask.index | The subtask index. | Any Str | true |
| flink.task.name | The task name. | Any Str | true |
| flink.taskmanager.id | The taskmanager ID. | Any Str | true |
| host.name | The host name. | Any Str | true |
