[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# github

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### vcs.change.count

The number of changes (pull requests) in a repository, categorized by their state (either open or merged).

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {change} | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| vcs.repository.url.full | The canonical URL of the repository providing the complete HTTPS address. | Any Str |
| vcs.change.state | The state of a change (pull request) | Str: ``open``, ``merged`` |
| vcs.repository.name | The name of the VCS repository. | Any Str |

### vcs.change.duration

The time duration a change (pull request/merge request/changelist) has been in an open state.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| vcs.repository.url.full | The canonical URL of the repository providing the complete HTTPS address. | Any Str |
| vcs.repository.name | The name of the VCS repository. | Any Str |
| vcs.ref.head.name | The name of the VCS head reference (branch). | Any Str |
| vcs.change.state | The state of a change (pull request) | Str: ``open``, ``merged`` |

### vcs.change.time_to_approval

The amount of time it took a change (pull request) to go from open to approved.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| vcs.repository.url.full | The canonical URL of the repository providing the complete HTTPS address. | Any Str |
| vcs.repository.name | The name of the VCS repository. | Any Str |
| vcs.ref.head.name | The name of the VCS head reference (branch). | Any Str |

### vcs.change.time_to_merge

The amount of time it took a change (pull request) to go from open to merged.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| vcs.repository.url.full | The canonical URL of the repository providing the complete HTTPS address. | Any Str |
| vcs.repository.name | The name of the VCS repository. | Any Str |
| vcs.ref.head.name | The name of the VCS head reference (branch). | Any Str |

### vcs.ref.count

The number of refs of type branch in a repository.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {ref} | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| vcs.repository.url.full | The canonical URL of the repository providing the complete HTTPS address. | Any Str |
| vcs.repository.name | The name of the VCS repository. | Any Str |
| vcs.ref.head.type | The type of the head reference (branch, tag). | Str: ``branch``, ``tag`` |

### vcs.ref.lines_delta

The number of lines added/removed in a ref (branch) relative to the default branch (trunk).

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {line} | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| vcs.repository.url.full | The canonical URL of the repository providing the complete HTTPS address. | Any Str |
| vcs.repository.name | The name of the VCS repository. | Any Str |
| vcs.ref.head.name | The name of the VCS head reference (branch). | Any Str |
| vcs.ref.head.type | The type of the head reference (branch, tag). | Str: ``branch``, ``tag`` |
| vcs.line_change.type | The type of line change being measured on a ref (branch). | Str: ``added``, ``removed`` |

### vcs.ref.revisions_delta

The number of revisions (commits) a ref (branch) is ahead/behind the branch from trunk (default).

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {revision} | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| vcs.repository.url.full | The canonical URL of the repository providing the complete HTTPS address. | Any Str |
| vcs.repository.name | The name of the VCS repository. | Any Str |
| vcs.ref.head.name | The name of the VCS head reference (branch). | Any Str |
| vcs.ref.head.type | The type of the head reference (branch, tag). | Str: ``branch``, ``tag`` |
| vcs.revision_delta.direction | The type of revision comparison. | Str: ``ahead``, ``behind`` |

### vcs.ref.time

Time a ref (branch) created from the default branch (trunk) has existed. The `vcs.ref.head.type` attribute will always be `branch`.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| vcs.repository.url.full | The canonical URL of the repository providing the complete HTTPS address. | Any Str |
| vcs.repository.name | The name of the VCS repository. | Any Str |
| vcs.ref.head.name | The name of the VCS head reference (branch). | Any Str |
| vcs.ref.head.type | The type of the head reference (branch, tag). | Str: ``branch``, ``tag`` |

### vcs.repository.count

The number of repositories in an organization.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {repository} | Gauge | Int |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### vcs.contributor.count

The number of unique contributors to a repository.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {contributor} | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| vcs.repository.url.full | The canonical URL of the repository providing the complete HTTPS address. | Any Str |
| vcs.repository.name | The name of the VCS repository. | Any Str |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| organization.name | VCS Organization | Any Str | true |
| vcs.vendor.name | The name of the VCS vendor/provider (ie. GitHub) | Any Str | true |
