# HAProxy Receiver

<!-- status autogenerated section -->
| Status        |           |
| ------------- |-----------|
| Stability     | [beta]: metrics   |
| Distributions | [contrib] |
| Issues        | [![Open issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aopen%20label%3Areceiver%2Fhaproxy%20&label=open&color=orange&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aopen+is%3Aissue+label%3Areceiver%2Fhaproxy) [![Closed issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aclosed%20label%3Areceiver%2Fhaproxy%20&label=closed&color=blue&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aclosed+is%3Aissue+label%3Areceiver%2Fhaproxy) |
| [Code Owners](https://github.com/open-telemetry/opentelemetry-collector-contrib/blob/main/CONTRIBUTING.md#becoming-a-code-owner)    | [@atoulme](https://www.github.com/atoulme), [@MovieStoreGuy](https://www.github.com/MovieStoreGuy) |

[beta]: https://github.com/open-telemetry/opentelemetry-collector/blob/main/docs/component-stability.md#beta
[contrib]: https://github.com/open-telemetry/opentelemetry-collector-releases/tree/main/distributions/otelcol-contrib
<!-- end autogenerated section -->

The HAProxy receiver generates metrics by polling periodically the HAProxy process through a dedicated socket or HTTP URL.

## Getting Started

## Configuration

### endpoint (required)
Path to the endpoint exposed by HAProxy for communications. It can be a local file socket or a HTTP URL.

### Collection interval settings (optional)
The scraping collection interval can be configured.

Default: 1 minute

### Initial delay settings (optional)
defines how long this receiver waits before starting.

Default: `1s` 

### Example configuration

```yaml
haproxy:
  endpoint: file:///var/run/haproxy.ipc
  collection_interval: 1m
  metrics:
    
```

## Enabling metrics.

See [documentation.md](./documentation.md).

You can enable or disable selective metrics.

Example:

```yaml
receivers:
  haproxy:
    endpoint: http://127.0.0.1:8080/stats
    metrics:
      haproxy.connection_rate:
        enabled: false
      haproxy.requests:
        enabled: true
```
