[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# haproxy

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### haproxy.bytes.input

Bytes in. Corresponds to HAProxy's `bin` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| by | Sum | Int | Cumulative | true |

### haproxy.bytes.output

Bytes out. Corresponds to HAProxy's `bout` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| by | Sum | Int | Cumulative | true |

### haproxy.connections.errors

Number of requests that encountered an error trying to connect to a backend server. The backend stat is the sum of the stat. Corresponds to HAProxy's `econ` metric

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {errors} | Sum | Int | Cumulative | true |

### haproxy.connections.rate

Number of connections over the last elapsed second (frontend). Corresponds to HAProxy's `conn_rate` metric.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {connections} | Gauge | Int |

### haproxy.connections.retries

Number of times a connection to a server was retried. Corresponds to HAProxy's `wretr` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {retries} | Sum | Int | Cumulative | true |

### haproxy.requests.denied

Requests denied because of security concerns. Corresponds to HAProxy's `dreq` metric

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {requests} | Sum | Int | Cumulative | true |

### haproxy.requests.errors

Cumulative number of request errors. Corresponds to HAProxy's `ereq` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {errors} | Sum | Int | Cumulative | true |

### haproxy.requests.queued

Current queued requests. For the backend this reports the number queued without a server assigned. Corresponds to HAProxy's `qcur` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {requests} | Sum | Int | Cumulative | true |

### haproxy.requests.rate

HTTP requests per second over last elapsed second. Corresponds to HAProxy's `req_rate` metric.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {requests} | Gauge | Double |

### haproxy.requests.redispatched

Number of times a request was redispatched to another server. Corresponds to HAProxy's `wredis` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {requests} | Sum | Int | Cumulative | true |

### haproxy.requests.total

Total number of HTTP requests received. Corresponds to HAProxy's `req_tot`, `hrsp_1xx`, `hrsp_2xx`, `hrsp_3xx`, `hrsp_4xx`, `hrsp_5xx` and `hrsp_other` metrics.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {requests} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| status_code | Status code category, 1xx, 2xx, 3xx, 4xx, 5xx or other | Str: ``1xx``, ``2xx``, ``3xx``, ``4xx``, ``5xx``, ``other`` |

### haproxy.responses.denied

Responses denied because of security concerns. Corresponds to HAProxy's `dresp` metric

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {responses} | Sum | Int | Cumulative | true |

### haproxy.responses.errors

Cumulative number of response errors. Corresponds to HAProxy's `eresp` metric, `srv_abrt` will be counted here also.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {errors} | Sum | Int | Cumulative | true |

### haproxy.server_selected.total

Number of times a server was selected, either for new sessions or when re-dispatching. Corresponds to HAProxy's `lbtot` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {selections} | Sum | Int | Cumulative | true |

### haproxy.sessions.average

Average total session time in ms over the last 1024 requests. Corresponds to HAProxy's `ttime` metric.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ms | Gauge | Double |

### haproxy.sessions.count

Current sessions. Corresponds to HAProxy's `scur` metric.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {sessions} | Gauge | Int |

### haproxy.sessions.rate

Number of sessions per second over last elapsed second. Corresponds to HAProxy's `rate` metric.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {sessions} | Gauge | Double |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### haproxy.clients.canceled

Number of data transfers aborted by the client. Corresponds to HAProxy's `cli_abrt` metric

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {cancellations} | Sum | Int | Cumulative | true |

### haproxy.compression.bypass

Number of bytes that bypassed the HTTP compressor (CPU/BW limit). Corresponds to HAProxy's `comp_byp` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| by | Sum | Int | Cumulative | true |

### haproxy.compression.count

Number of HTTP responses that were compressed. Corresponds to HAProxy's `comp_rsp` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {responses} | Sum | Int | Cumulative | true |

### haproxy.compression.input

Number of HTTP response bytes fed to the compressor. Corresponds to HAProxy's `comp_in` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| by | Sum | Int | Cumulative | true |

### haproxy.compression.output

Number of HTTP response bytes emitted by the compressor. Corresponds to HAProxy's `comp_out` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| by | Sum | Int | Cumulative | true |

### haproxy.connections.total

Cumulative number of connections (frontend). Corresponds to HAProxy's `conn_tot` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections} | Sum | Int | Cumulative | true |

### haproxy.downtime

Total downtime (in seconds). The value for the backend is the downtime for the whole backend, not the sum of the server downtime. Corresponds to HAProxy's `downtime` metric

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| s | Sum | Int | Cumulative | true |

### haproxy.failed_checks

Number of failed checks. (Only counts checks failed when the server is up). Corresponds to HAProxy's `chkfail` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {checks} | Sum | Int | Cumulative | true |

### haproxy.sessions.total

Cumulative number of sessions. Corresponds to HAProxy's `stot` metric.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {sessions} | Sum | Int | Cumulative | true |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| haproxy.addr | address:port or "unix". IPv6 has brackets around the address. | Any Str | true |
| haproxy.proxy_name | Proxy name | Any Str | true |
| haproxy.service_name | Service name (FRONTEND for frontend, BACKEND for backend, any name for server/listener) | Any Str | true |
