[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# kafkametrics

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### kafka.brokers

Number of brokers in the cluster.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {brokers} | Sum | Int | Cumulative | false |

### kafka.consumer_group.lag

Current approximate lag of consumer group at partition of topic

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| group | The ID (string) of a consumer group | Any Str |
| topic | The ID (integer) of a topic | Any Str |
| partition | The number (integer) of the partition | Any Int |

### kafka.consumer_group.lag_sum

Current approximate sum of consumer group lag across all partitions of topic

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| group | The ID (string) of a consumer group | Any Str |
| topic | The ID (integer) of a topic | Any Str |

### kafka.consumer_group.members

Count of members in the consumer group

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {members} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| group | The ID (string) of a consumer group | Any Str |

### kafka.consumer_group.offset

Current offset of the consumer group at partition of topic

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| group | The ID (string) of a consumer group | Any Str |
| topic | The ID (integer) of a topic | Any Str |
| partition | The number (integer) of the partition | Any Int |

### kafka.consumer_group.offset_sum

Sum of consumer group offset across partitions of topic

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| group | The ID (string) of a consumer group | Any Str |
| topic | The ID (integer) of a topic | Any Str |

### kafka.partition.current_offset

Current offset of partition of topic.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The ID (integer) of a topic | Any Str |
| partition | The number (integer) of the partition | Any Int |

### kafka.partition.oldest_offset

Oldest offset of partition of topic

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The ID (integer) of a topic | Any Str |
| partition | The number (integer) of the partition | Any Int |

### kafka.partition.replicas

Number of replicas for partition of topic

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {replicas} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The ID (integer) of a topic | Any Str |
| partition | The number (integer) of the partition | Any Int |

### kafka.partition.replicas_in_sync

Number of synchronized replicas of partition

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {replicas} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The ID (integer) of a topic | Any Str |
| partition | The number (integer) of the partition | Any Int |

### kafka.topic.partitions

Number of partitions in topic.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {partitions} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The ID (integer) of a topic | Any Str |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### kafka.broker.log_retention_period

log retention time (s) of a broker.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| broker | The ID of the kafka broker | Any Str |

### kafka.topic.log_retention_period

log retention period of a topic (s).

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The ID (integer) of a topic | Any Str |

### kafka.topic.log_retention_size

log retention size of a topic in Bytes, The value (-1) indicates infinite size.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The ID (integer) of a topic | Any Str |

### kafka.topic.min_insync_replicas

minimum in-sync replicas of a topic.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {replicas} | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The ID (integer) of a topic | Any Str |

### kafka.topic.replication_factor

replication factor of a topic.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The ID (integer) of a topic | Any Str |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| kafka.cluster.alias | The alias name (string) of the cluster | Any Str | false |
