[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# memcached

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### memcached.bytes

Current number of bytes used by this server to store items.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Int |

### memcached.commands

Commands executed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {commands} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| command | The type of command. | Str: ``get``, ``set``, ``flush``, ``touch`` |

### memcached.connections.current

The current number of open connections.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections} | Sum | Int | Cumulative | false |

### memcached.connections.total

Total number of connections opened since the server started running.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections} | Sum | Int | Cumulative | true |

### memcached.cpu.usage

Accumulated user and system time.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| s | Sum | Double | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| state | The type of CPU usage. | Str: ``system``, ``user`` |

### memcached.current_items

Number of items currently stored in the cache.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {items} | Sum | Int | Cumulative | false |

### memcached.evictions

Cache item evictions.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {evictions} | Sum | Int | Cumulative | true |

### memcached.network

Bytes transferred over the network.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| by | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| direction | Direction of data flow. | Str: ``sent``, ``received`` |

### memcached.operation_hit_ratio

Hit ratio for operations, expressed as a percentage value between 0.0 and 100.0.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| % | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| operation | The type of operation. | Str: ``increment``, ``decrement``, ``get`` |

### memcached.operations

Operation counts.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {operations} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | Result of cache request. | Str: ``hit``, ``miss`` |
| operation | The type of operation. | Str: ``increment``, ``decrement``, ``get`` |

### memcached.threads

Number of threads used by the memcached instance.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {threads} | Sum | Int | Cumulative | false |
