[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# mongodbatlas

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### mongodbatlas.db.counts

Database feature size

Aggregate of MongoDB Metrics DATABASE_EXTENT_COUNT, DATABASE_VIEW_COUNT, DATABASE_COLLECTION_COUNT, DATABASE_OBJECT_COUNT, DATABASE_INDEX_COUNT

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {objects} | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| object_type | MongoDB object type | Str: ``collection``, ``index``, ``extent``, ``object``, ``view``, ``storage``, ``data`` |

### mongodbatlas.db.size

Database feature size

Aggregate of MongoDB Metrics DATABASE_DATA_SIZE, DATABASE_STORAGE_SIZE, DATABASE_INDEX_SIZE, DATABASE_AVERAGE_OBJECT_SIZE

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| object_type | MongoDB object type | Str: ``collection``, ``index``, ``extent``, ``object``, ``view``, ``storage``, ``data`` |

### mongodbatlas.disk.partition.iops.average

Disk partition iops

Aggregate of MongoDB Metrics DISK_PARTITION_IOPS_READ, DISK_PARTITION_IOPS_WRITE, DISK_PARTITION_IOPS_TOTAL

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {ops}/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| disk_direction | Measurement type for disk operation | Str: ``read``, ``write``, ``total`` |

### mongodbatlas.disk.partition.iops.max

Disk partition iops

Aggregate of MongoDB Metrics MAX_DISK_PARTITION_IOPS_WRITE, MAX_DISK_PARTITION_IOPS_TOTAL, MAX_DISK_PARTITION_IOPS_READ

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {ops}/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| disk_direction | Measurement type for disk operation | Str: ``read``, ``write``, ``total`` |

### mongodbatlas.disk.partition.latency.average

Disk partition latency

Aggregate of MongoDB Metrics DISK_PARTITION_LATENCY_WRITE, DISK_PARTITION_LATENCY_READ

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ms | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| disk_direction | Measurement type for disk operation | Str: ``read``, ``write``, ``total`` |

### mongodbatlas.disk.partition.latency.max

Disk partition latency

Aggregate of MongoDB Metrics MAX_DISK_PARTITION_LATENCY_WRITE, MAX_DISK_PARTITION_LATENCY_READ

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ms | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| disk_direction | Measurement type for disk operation | Str: ``read``, ``write``, ``total`` |

### mongodbatlas.disk.partition.space.average

Disk partition space

Aggregate of MongoDB Metrics DISK_PARTITION_SPACE_FREE, DISK_PARTITION_SPACE_USED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| disk_status | Disk measurement type | Str: ``free``, ``used`` |

### mongodbatlas.disk.partition.space.max

Disk partition space

Aggregate of MongoDB Metrics DISK_PARTITION_SPACE_FREE, DISK_PARTITION_SPACE_USED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| disk_status | Disk measurement type | Str: ``free``, ``used`` |

### mongodbatlas.disk.partition.usage.average

Disk partition usage (%)

Aggregate of MongoDB Metrics DISK_PARTITION_SPACE_PERCENT_FREE, DISK_PARTITION_SPACE_PERCENT_USED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| disk_status | Disk measurement type | Str: ``free``, ``used`` |

### mongodbatlas.disk.partition.usage.max

Disk partition usage (%)

Aggregate of MongoDB Metrics MAX_DISK_PARTITION_SPACE_PERCENT_USED, MAX_DISK_PARTITION_SPACE_PERCENT_FREE

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| disk_status | Disk measurement type | Str: ``free``, ``used`` |

### mongodbatlas.disk.partition.utilization.average

The percentage of time during which requests are being issued to and serviced by the partition.

MongoDB Metrics DISK_PARTITION_UTILIZATION

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

### mongodbatlas.disk.partition.utilization.max

The maximum percentage of time during which requests are being issued to and serviced by the partition.

MongoDB Metrics MAX_DISK_PARTITION_UTILIZATION

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

### mongodbatlas.process.asserts

Number of assertions per second

Aggregate of MongoDB Metrics ASSERT_REGULAR, ASSERT_USER, ASSERT_MSG, ASSERT_WARNING

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {assertions}/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| assert_type | MongoDB assertion type | Str: ``regular``, ``warning``, ``msg``, ``user`` |

### mongodbatlas.process.background_flush

Amount of data flushed in the background

MongoDB Metric BACKGROUND_FLUSH_AVG

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

### mongodbatlas.process.cache.io

Cache throughput (per second)

Aggregate of MongoDB Metrics CACHE_BYTES_READ_INTO, CACHE_BYTES_WRITTEN_FROM

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cache_direction | Whether read into or written from | Str: ``read_into``, ``written_from`` |

### mongodbatlas.process.cache.size

Cache sizes

Aggregate of MongoDB Metrics CACHE_USED_BYTES, CACHE_DIRTY_BYTES

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Double | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cache_status | Cache status | Str: ``dirty``, ``used`` |

### mongodbatlas.process.connections

Number of current connections

MongoDB Metric CONNECTIONS

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections} | Sum | Double | Cumulative | false |

### mongodbatlas.process.cpu.children.normalized.usage.average

CPU Usage for child processes, normalized to pct

Aggregate of MongoDB Metrics PROCESS_NORMALIZED_CPU_CHILDREN_KERNEL, PROCESS_NORMALIZED_CPU_CHILDREN_USER

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.process.cpu.children.normalized.usage.max

CPU Usage for child processes, normalized to pct

Aggregate of MongoDB Metrics MAX_PROCESS_NORMALIZED_CPU_CHILDREN_KERNEL, MAX_PROCESS_NORMALIZED_CPU_CHILDREN_USER

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.process.cpu.children.usage.average

CPU Usage for child processes (%)

Aggregate of MongoDB Metrics PROCESS_CPU_CHILDREN_KERNEL, PROCESS_CPU_CHILDREN_USER

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.process.cpu.children.usage.max

CPU Usage for child processes (%)

Aggregate of MongoDB Metrics MAX_PROCESS_CPU_CHILDREN_USER, MAX_PROCESS_CPU_CHILDREN_KERNEL

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.process.cpu.normalized.usage.average

CPU Usage, normalized to pct

Aggregate of MongoDB Metrics PROCESS_NORMALIZED_CPU_KERNEL, PROCESS_NORMALIZED_CPU_USER

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.process.cpu.normalized.usage.max

CPU Usage, normalized to pct

Aggregate of MongoDB Metrics MAX_PROCESS_NORMALIZED_CPU_USER, MAX_PROCESS_NORMALIZED_CPU_KERNEL

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.process.cpu.usage.average

CPU Usage (%)

Aggregate of MongoDB Metrics PROCESS_CPU_KERNEL, PROCESS_CPU_USER

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.process.cpu.usage.max

CPU Usage (%)

Aggregate of MongoDB Metrics MAX_PROCESS_CPU_KERNEL, MAX_PROCESS_CPU_USER

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.process.cursors

Number of cursors

Aggregate of MongoDB Metrics CURSORS_TOTAL_OPEN, CURSORS_TOTAL_TIMED_OUT

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {cursors} | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cursor_state | Whether cursor is open or timed out | Str: ``timed_out``, ``open`` |

### mongodbatlas.process.db.document.rate

Document access rates

Aggregate of MongoDB Metrics DOCUMENT_METRICS_UPDATED, DOCUMENT_METRICS_DELETED, DOCUMENT_METRICS_RETURNED, DOCUMENT_METRICS_INSERTED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {documents}/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| document_status | Status of documents in the database | Str: ``returned``, ``inserted``, ``updated``, ``deleted`` |

### mongodbatlas.process.db.operations.rate

DB Operation Rates

Aggregate of MongoDB Metrics OPCOUNTER_GETMORE, OPERATIONS_SCAN_AND_ORDER, OPCOUNTER_UPDATE, OPCOUNTER_REPL_UPDATE, OPCOUNTER_CMD, OPCOUNTER_DELETE, OPCOUNTER_REPL_DELETE, OPCOUNTER_REPL_CMD, OPCOUNTER_QUERY, OPCOUNTER_REPL_INSERT, OPCOUNTER_INSERT, OPCOUNTER_TTL_DELETED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {operations}/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| operation | Type of database operation | Str: ``cmd``, ``query``, ``update``, ``delete``, ``getmore``, ``insert``, ``scan_and_order``, ``ttl_deleted`` |
| cluster_role | Whether process is acting as replica or primary | Str: ``primary``, ``replica`` |

### mongodbatlas.process.db.operations.time

DB Operation Times

Aggregate of MongoDB Metrics OP_EXECUTION_TIME_WRITES, OP_EXECUTION_TIME_COMMANDS, OP_EXECUTION_TIME_READS

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| ms | Sum | Double | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| execution_type | Type of command | Str: ``reads``, ``writes``, ``commands`` |

### mongodbatlas.process.db.query_executor.scanned

Scanned objects

Aggregate of MongoDB Metrics QUERY_EXECUTOR_SCANNED_OBJECTS, QUERY_EXECUTOR_SCANNED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {objects}/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| scanned_type | Objects or indexes scanned during query | Str: ``index_items``, ``objects`` |

### mongodbatlas.process.db.query_targeting.scanned_per_returned

Scanned objects per returned

Aggregate of MongoDB Metrics QUERY_TARGETING_SCANNED_OBJECTS_PER_RETURNED, QUERY_TARGETING_SCANNED_PER_RETURNED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {scanned}/{returned} | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| scanned_type | Objects or indexes scanned during query | Str: ``index_items``, ``objects`` |

### mongodbatlas.process.db.storage

Storage used by the database

Aggregate of MongoDB Metrics DB_INDEX_SIZE_TOTAL, DB_DATA_SIZE_TOTAL_WO_SYSTEM, DB_STORAGE_TOTAL, DB_DATA_SIZE_TOTAL

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| storage_status | Views on database size | Str: ``total``, ``data_size``, ``index_size``, ``data_size_wo_system`` |

### mongodbatlas.process.global_lock

Number and status of locks

Aggregate of MongoDB Metrics GLOBAL_LOCK_CURRENT_QUEUE_WRITERS, GLOBAL_LOCK_CURRENT_QUEUE_READERS, GLOBAL_LOCK_CURRENT_QUEUE_TOTAL

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {locks} | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| global_lock_state | Which queue is locked | Str: ``current_queue_total``, ``current_queue_readers``, ``current_queue_writers`` |

### mongodbatlas.process.index.btree_miss_ratio

Index miss ratio (%)

MongoDB Metric INDEX_COUNTERS_BTREE_MISS_RATIO

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

### mongodbatlas.process.index.counters

Indexes

Aggregate of MongoDB Metrics INDEX_COUNTERS_BTREE_MISSES, INDEX_COUNTERS_BTREE_ACCESSES, INDEX_COUNTERS_BTREE_HITS

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {indexes} | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| btree_counter_type | Database index effectiveness | Str: ``accesses``, ``hits``, ``misses`` |

### mongodbatlas.process.journaling.commits

Journaling commits

MongoDB Metric JOURNALING_COMMITS_IN_WRITE_LOCK

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {commits} | Gauge | Double |

### mongodbatlas.process.journaling.data_files

Data file sizes

MongoDB Metric JOURNALING_WRITE_DATA_FILES_MB

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| MiBy | Gauge | Double |

### mongodbatlas.process.journaling.written

Journals written

MongoDB Metric JOURNALING_MB

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| MiBy | Gauge | Double |

### mongodbatlas.process.memory.usage

Memory Usage

Aggregate of MongoDB Metrics MEMORY_MAPPED, MEMORY_VIRTUAL, COMPUTED_MEMORY, MEMORY_RESIDENT

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| memory_state | Memory usage type | Str: ``resident``, ``virtual``, ``mapped``, ``computed``, ``shared``, ``free``, ``used`` |

### mongodbatlas.process.network.io

Network IO

Aggregate of MongoDB Metrics NETWORK_BYTES_OUT, NETWORK_BYTES_IN

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| direction | Network traffic direction | Str: ``receive``, ``transmit`` |

### mongodbatlas.process.network.requests

Network requests

MongoDB Metric NETWORK_NUM_REQUESTS

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {requests} | Sum | Double | Cumulative | true |

### mongodbatlas.process.oplog.rate

Execution rate by operation

MongoDB Metric OPLOG_RATE_GB_PER_HOUR

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| GiBy/h | Gauge | Double |

### mongodbatlas.process.oplog.time

Execution time by operation

Aggregate of MongoDB Metrics OPLOG_MASTER_TIME, OPLOG_SLAVE_LAG_MASTER_TIME, OPLOG_MASTER_LAG_TIME_DIFF

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| oplog_type | Oplog type | Str: ``slave_lag_master_time``, ``master_time``, ``master_lag_time_diff`` |

### mongodbatlas.process.page_faults

Page faults

Aggregate of MongoDB Metrics GLOBAL_PAGE_FAULT_EXCEPTIONS_THROWN, EXTRA_INFO_PAGE_FAULTS, GLOBAL_ACCESSES_NOT_IN_MEMORY

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {faults}/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| memory_issue_type | Type of memory issue encountered | Str: ``extra_info``, ``global_accesses_not_in_memory``, ``exceptions_thrown`` |

### mongodbatlas.process.restarts

Restarts in last hour

Aggregate of MongoDB Metrics RESTARTS_IN_LAST_HOUR

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {restarts}/h | Gauge | Double |

### mongodbatlas.process.tickets

Tickets

Aggregate of MongoDB Metrics TICKETS_AVAILABLE_WRITE, TICKETS_AVAILABLE_READS

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {tickets} | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| ticket_type | Type of ticket available | Str: ``available_reads``, ``available_writes`` |

### mongodbatlas.system.cpu.normalized.usage.average

System CPU Normalized to pct

Aggregate of MongoDB Metrics SYSTEM_NORMALIZED_CPU_IOWAIT, SYSTEM_NORMALIZED_CPU_GUEST, SYSTEM_NORMALIZED_CPU_IRQ, SYSTEM_NORMALIZED_CPU_KERNEL, SYSTEM_NORMALIZED_CPU_STEAL, SYSTEM_NORMALIZED_CPU_SOFTIRQ, SYSTEM_NORMALIZED_CPU_NICE, SYSTEM_NORMALIZED_CPU_USER

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.system.cpu.normalized.usage.max

System CPU Normalized to pct

Aggregate of MongoDB Metrics MAX_SYSTEM_NORMALIZED_CPU_USER, MAX_SYSTEM_NORMALIZED_CPU_NICE, MAX_SYSTEM_NORMALIZED_CPU_IOWAIT, MAX_SYSTEM_NORMALIZED_CPU_SOFTIRQ, MAX_SYSTEM_NORMALIZED_CPU_STEAL, MAX_SYSTEM_NORMALIZED_CPU_KERNEL, MAX_SYSTEM_NORMALIZED_CPU_GUEST, MAX_SYSTEM_NORMALIZED_CPU_IRQ

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.system.cpu.usage.average

System CPU Usage (%)

Aggregate of MongoDB Metrics SYSTEM_CPU_USER, SYSTEM_CPU_GUEST, SYSTEM_CPU_SOFTIRQ, SYSTEM_CPU_IRQ, SYSTEM_CPU_KERNEL, SYSTEM_CPU_IOWAIT, SYSTEM_CPU_NICE, SYSTEM_CPU_STEAL

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.system.cpu.usage.max

System CPU Usage (%)

Aggregate of MongoDB Metrics MAX_SYSTEM_CPU_SOFTIRQ, MAX_SYSTEM_CPU_IRQ, MAX_SYSTEM_CPU_GUEST, MAX_SYSTEM_CPU_IOWAIT, MAX_SYSTEM_CPU_NICE, MAX_SYSTEM_CPU_KERNEL, MAX_SYSTEM_CPU_USER, MAX_SYSTEM_CPU_STEAL

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.system.fts.cpu.normalized.usage

Full text search disk usage (%)

Aggregate of MongoDB Metrics FTS_PROCESS_NORMALIZED_CPU_USER, FTS_PROCESS_NORMALIZED_CPU_KERNEL

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.system.fts.cpu.usage

Full-text search (%)

Aggregate of MongoDB Metrics FTS_PROCESS_CPU_USER, FTS_PROCESS_CPU_KERNEL

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cpu_state | CPU state | Str: ``kernel``, ``user``, ``nice``, ``iowait``, ``irq``, ``softirq``, ``guest``, ``steal`` |

### mongodbatlas.system.fts.disk.used

Full text search disk usage

MongoDB Metric FTS_DISK_USAGE

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

### mongodbatlas.system.fts.memory.usage

Full-text search

Aggregate of MongoDB Metrics FTS_MEMORY_MAPPED, FTS_PROCESS_SHARED_MEMORY, FTS_PROCESS_RESIDENT_MEMORY, FTS_PROCESS_VIRTUAL_MEMORY

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| MiBy | Sum | Double | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| memory_state | Memory usage type | Str: ``resident``, ``virtual``, ``mapped``, ``computed``, ``shared``, ``free``, ``used`` |

### mongodbatlas.system.memory.usage.average

System Memory Usage

Aggregate of MongoDB Metrics SYSTEM_MEMORY_AVAILABLE, SYSTEM_MEMORY_BUFFERS, SYSTEM_MEMORY_USED, SYSTEM_MEMORY_CACHED, SYSTEM_MEMORY_SHARED, SYSTEM_MEMORY_FREE

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| KiBy | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| memory_status | Memory measurement type | Str: ``available``, ``buffers``, ``cached``, ``free``, ``shared``, ``used`` |

### mongodbatlas.system.memory.usage.max

System Memory Usage

Aggregate of MongoDB Metrics MAX_SYSTEM_MEMORY_CACHED, MAX_SYSTEM_MEMORY_AVAILABLE, MAX_SYSTEM_MEMORY_USED, MAX_SYSTEM_MEMORY_BUFFERS, MAX_SYSTEM_MEMORY_FREE, MAX_SYSTEM_MEMORY_SHARED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| KiBy | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| memory_status | Memory measurement type | Str: ``available``, ``buffers``, ``cached``, ``free``, ``shared``, ``used`` |

### mongodbatlas.system.network.io.average

System Network IO

Aggregate of MongoDB Metrics SYSTEM_NETWORK_IN, SYSTEM_NETWORK_OUT

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| direction | Network traffic direction | Str: ``receive``, ``transmit`` |

### mongodbatlas.system.network.io.max

System Network IO

Aggregate of MongoDB Metrics MAX_SYSTEM_NETWORK_OUT, MAX_SYSTEM_NETWORK_IN

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| direction | Network traffic direction | Str: ``receive``, ``transmit`` |

### mongodbatlas.system.paging.io.average

Swap IO

Aggregate of MongoDB Metrics SWAP_IO_IN, SWAP_IO_OUT

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {pages}/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| direction | Network traffic direction | Str: ``receive``, ``transmit`` |

### mongodbatlas.system.paging.io.max

Swap IO

Aggregate of MongoDB Metrics MAX_SWAP_IO_IN, MAX_SWAP_IO_OUT

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {pages}/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| direction | Network traffic direction | Str: ``receive``, ``transmit`` |

### mongodbatlas.system.paging.usage.average

Swap usage

Aggregate of MongoDB Metrics SWAP_USAGE_FREE, SWAP_USAGE_USED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| KiBy | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| memory_state | Memory usage type | Str: ``resident``, ``virtual``, ``mapped``, ``computed``, ``shared``, ``free``, ``used`` |

### mongodbatlas.system.paging.usage.max

Swap usage

Aggregate of MongoDB Metrics MAX_SWAP_USAGE_FREE, MAX_SWAP_USAGE_USED

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| KiBy | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| memory_state | Memory usage type | Str: ``resident``, ``virtual``, ``mapped``, ``computed``, ``shared``, ``free``, ``used`` |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### mongodbatlas.disk.partition.queue.depth

Disk queue depth

Aggregate of MongoDB Metrics DISK_QUEUE_DEPTH

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

### mongodbatlas.disk.partition.throughput

Disk throughput

Aggregate of MongoDB Metrics DISK_PARTITION_THROUGHPUT_READ, DISK_PARTITION_THROUGHPUT_WRITE

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By/s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| disk_direction | Measurement type for disk operation | Str: ``read``, ``write``, ``total`` |

### mongodbatlas.process.cache.ratio

Cache ratios represented as (%)

Aggregate of MongoDB Metrics CACHE_FILL_RATIO, DIRTY_FILL_RATIO

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| % | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| cache_ratio_type | Cache ratio type | Str: ``cache_fill``, ``dirty_fill`` |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| mongodb_atlas.cluster.name | Cluster Name | Any Str | false |
| mongodb_atlas.db.name | Name of the Database | Any Str | true |
| mongodb_atlas.disk.partition | Name of a disk partition | Any Str | true |
| mongodb_atlas.host.name | Hostname of the process | Any Str | true |
| mongodb_atlas.org_name | Organization Name | Any Str | true |
| mongodb_atlas.process.id | ID of the process | Any Str | true |
| mongodb_atlas.process.port | Port process is bound to | Any Str | true |
| mongodb_atlas.process.type_name | Process type | Any Str | true |
| mongodb_atlas.project.id | Project ID | Any Str | true |
| mongodb_atlas.project.name | Project Name | Any Str | true |
| mongodb_atlas.provider.name | Provider Name | Any Str | false |
| mongodb_atlas.region.name | Region Name | Any Str | false |
| mongodb_atlas.user.alias | User-friendly hostname of the cluster node | Any Str | false |
