// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"go.opentelemetry.io/collector/pdata/pcommon"
)

// ResourceBuilder is a helper struct to build resources predefined in metadata.yaml.
// The ResourceBuilder is not thread-safe and must not to be used in multiple goroutines.
type ResourceBuilder struct {
	config ResourceAttributesConfig
	res    pcommon.Resource
}

// NewResourceBuilder creates a new ResourceBuilder. This method should be called on the start of the application.
func NewResourceBuilder(rac ResourceAttributesConfig) *ResourceBuilder {
	return &ResourceBuilder{
		config: rac,
		res:    pcommon.NewResource(),
	}
}

// SetDeviceID sets provided value as "device.id" attribute.
func (rb *ResourceBuilder) SetDeviceID(val string) {
	if rb.config.DeviceID.Enabled {
		rb.res.Attributes().PutStr("device.id", val)
	}
}

// SetNsxtNodeID sets provided value as "nsxt.node.id" attribute.
func (rb *ResourceBuilder) SetNsxtNodeID(val string) {
	if rb.config.NsxtNodeID.Enabled {
		rb.res.Attributes().PutStr("nsxt.node.id", val)
	}
}

// SetNsxtNodeName sets provided value as "nsxt.node.name" attribute.
func (rb *ResourceBuilder) SetNsxtNodeName(val string) {
	if rb.config.NsxtNodeName.Enabled {
		rb.res.Attributes().PutStr("nsxt.node.name", val)
	}
}

// SetNsxtNodeType sets provided value as "nsxt.node.type" attribute.
func (rb *ResourceBuilder) SetNsxtNodeType(val string) {
	if rb.config.NsxtNodeType.Enabled {
		rb.res.Attributes().PutStr("nsxt.node.type", val)
	}
}

// Emit returns the built resource and resets the internal builder state.
func (rb *ResourceBuilder) Emit() pcommon.Resource {
	r := rb.res
	rb.res = pcommon.NewResource()
	return r
}
