[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# oracledb

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### oracledb.cpu_time

Cumulative CPU time, in seconds

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| s | Sum | Double | Cumulative | true |

### oracledb.dml_locks.limit

Maximum limit of active DML (Data Manipulation Language) locks, -1 if unlimited.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {locks} | Gauge | Int |

### oracledb.dml_locks.usage

Current count of active DML (Data Manipulation Language) locks.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {locks} | Gauge | Int |

### oracledb.enqueue_deadlocks

Total number of deadlocks between table or row locks in different sessions.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {deadlocks} | Sum | Int | Cumulative | true |

### oracledb.enqueue_locks.limit

Maximum limit of active enqueue locks, -1 if unlimited.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {locks} | Gauge | Int |

### oracledb.enqueue_locks.usage

Current count of active enqueue locks.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {locks} | Gauge | Int |

### oracledb.enqueue_resources.limit

Maximum limit of active enqueue resources, -1 if unlimited.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {resources} | Gauge | Int |

### oracledb.enqueue_resources.usage

Current count of active enqueue resources.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {resources} | Gauge | Int |

### oracledb.exchange_deadlocks

Number of times that a process detected a potential deadlock when exchanging two buffers and raised an internal, restartable error. Index scans are the only operations that perform exchanges.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {deadlocks} | Sum | Int | Cumulative | true |

### oracledb.executions

Total number of calls (user and recursive) that executed SQL statements

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {executions} | Sum | Int | Cumulative | true |

### oracledb.hard_parses

Number of hard parses

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {parses} | Sum | Int | Cumulative | true |

### oracledb.logical_reads

Number of logical reads

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {reads} | Sum | Int | Cumulative | true |

### oracledb.parse_calls

Total number of parse calls.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {parses} | Sum | Int | Cumulative | true |

### oracledb.pga_memory

Session PGA (Program Global Area) memory

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | true |

### oracledb.physical_reads

Number of physical reads

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {reads} | Sum | Int | Cumulative | true |

### oracledb.processes.limit

Maximum limit of active processes, -1 if unlimited.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {processes} | Gauge | Int |

### oracledb.processes.usage

Current count of active processes.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {processes} | Gauge | Int |

### oracledb.sessions.limit

Maximum limit of active sessions, -1 if unlimited.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {sessions} | Gauge | Int |

### oracledb.sessions.usage

Count of active sessions.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {sessions} | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| session_type | Session type | Any Str |
| session_status | Session status | Any Str |

### oracledb.tablespace_size.limit

Maximum size of tablespace in bytes, -1 if unlimited.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| tablespace_name | Tablespace name | Any Str |

### oracledb.tablespace_size.usage

Used tablespace in bytes.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| tablespace_name | Tablespace name | Any Str |

### oracledb.transactions.limit

Maximum limit of active transactions, -1 if unlimited.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {transactions} | Gauge | Int |

### oracledb.transactions.usage

Current count of active transactions.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {transactions} | Gauge | Int |

### oracledb.user_commits

Number of user commits. When a user commits a transaction, the redo generated that reflects the changes made to database blocks must be written to disk. Commits often represent the closest thing to a user transaction rate.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {commits} | Sum | Int | Cumulative | true |

### oracledb.user_rollbacks

Number of times users manually issue the ROLLBACK statement or an error occurs during a user's transactions

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| 1 | Sum | Int | Cumulative | true |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### oracledb.consistent_gets

Number of times a consistent read was requested for a block from the buffer cache.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {gets} | Sum | Int | Cumulative | true |

### oracledb.db_block_gets

Number of times a current block was requested from the buffer cache.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {gets} | Sum | Int | Cumulative | true |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| oracledb.instance.name | The name of the instance that data is coming from. | Any Str | true |
