[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# postgresql

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### postgresql.backends

The number of backends.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| 1 | Sum | Int | Cumulative | false |

### postgresql.bgwriter.buffers.allocated

Number of buffers allocated.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {buffers} | Sum | Int | Cumulative | true |

### postgresql.bgwriter.buffers.writes

Number of buffers written.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {buffers} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| source | The source of a buffer write. | Str: ``backend``, ``backend_fsync``, ``checkpoints``, ``bgwriter`` |

### postgresql.bgwriter.checkpoint.count

The number of checkpoints performed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {checkpoints} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | The type of checkpoint state. | Str: ``requested``, ``scheduled`` |

### postgresql.bgwriter.duration

Total time spent writing and syncing files to disk by checkpoints.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| ms | Sum | Double | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | The type of time spent during the checkpoint. | Str: ``sync``, ``write`` |

### postgresql.bgwriter.maxwritten

Number of times the background writer stopped a cleaning scan because it had written too many buffers.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| 1 | Sum | Int | Cumulative | true |

### postgresql.blocks_read

The number of blocks read.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| 1 | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| source | The block read source type. | Str: ``heap_read``, ``heap_hit``, ``idx_read``, ``idx_hit``, ``toast_read``, ``toast_hit``, ``tidx_read``, ``tidx_hit`` |

### postgresql.commits

The number of commits.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| 1 | Sum | Int | Cumulative | true |

### postgresql.connection.max

Configured maximum number of client connections allowed

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {connections} | Gauge | Int |

### postgresql.database.count

Number of user databases.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {databases} | Sum | Int | Cumulative | false |

### postgresql.db_size

The database disk usage.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### postgresql.index.scans

The number of index scans on a table.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {scans} | Sum | Int | Cumulative | true |

### postgresql.index.size

The size of the index on disk.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Int |

### postgresql.operations

The number of db row operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| 1 | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| operation | The database operation. | Str: ``ins``, ``upd``, ``del``, ``hot_upd`` |

### postgresql.replication.data_delay

The amount of data delayed in replication.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| replication_client | The IP address of the client connected to this backend. If this field is "unix", it indicates either that the client is connected via a Unix socket. | Any Str |

### postgresql.rollbacks

The number of rollbacks.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| 1 | Sum | Int | Cumulative | true |

### postgresql.rows

The number of rows in the database.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| 1 | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| state | The tuple (row) state. | Str: ``dead``, ``live`` |

### postgresql.table.count

Number of user tables in a database.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {table} | Sum | Int | Cumulative | false |

### postgresql.table.size

Disk space used by a table.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### postgresql.table.vacuum.count

Number of times a table has manually been vacuumed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {vacuums} | Sum | Int | Cumulative | true |

### postgresql.wal.age

Age of the oldest WAL file.

This metric requires WAL to be enabled with at least one replica.


| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

### postgresql.wal.lag

Time between flushing recent WAL locally and receiving notification that the standby server has completed an operation with it.

This metric requires WAL to be enabled with at least one replica.


| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| operation | The operation which is responsible for the lag. | Str: ``flush``, ``replay``, ``write`` |
| replication_client | The IP address of the client connected to this backend. If this field is "unix", it indicates either that the client is connected via a Unix socket. | Any Str |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### postgresql.blks_hit

Number of times disk blocks were found already in the buffer cache.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {blks_hit} | Sum | Int | Cumulative | true |

### postgresql.blks_read

Number of disk blocks read in this database.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {blks_read} | Sum | Int | Cumulative | true |

### postgresql.database.locks

The number of database locks.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {lock} | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| relation | OID of the relation targeted by the lock, or null if the target is not a relation or part of a relation. | Any Str |
| mode | Name of the lock mode held or desired by the process. | Any Str |
| lock_type | Type of the lockable object. | Any Str |

### postgresql.deadlocks

The number of deadlocks.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {deadlock} | Sum | Int | Cumulative | true |

### postgresql.sequential_scans

The number of sequential scans.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {sequential_scan} | Sum | Int | Cumulative | true |

### postgresql.temp_files

The number of temp files.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {temp_file} | Sum | Int | Cumulative | true |

### postgresql.tup_deleted

Number of rows deleted by queries in the database.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {tup_deleted} | Sum | Int | Cumulative | true |

### postgresql.tup_fetched

Number of rows fetched by queries in the database.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {tup_fetched} | Sum | Int | Cumulative | true |

### postgresql.tup_inserted

Number of rows inserted by queries in the database.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {tup_inserted} | Sum | Int | Cumulative | true |

### postgresql.tup_returned

Number of rows returned by queries in the database.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {tup_returned} | Sum | Int | Cumulative | true |

### postgresql.tup_updated

Number of rows updated by queries in the database.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {tup_updated} | Sum | Int | Cumulative | true |

### postgresql.wal.delay

Time between flushing recent WAL locally and receiving notification that the standby server has completed an operation with it.

This metric requires WAL to be enabled with at least one replica.


| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| operation | The operation which is responsible for the lag. | Str: ``flush``, ``replay``, ``write`` |
| replication_client | The IP address of the client connected to this backend. If this field is "unix", it indicates either that the client is connected via a Unix socket. | Any Str |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| postgresql.database.name | The name of the database. | Any Str | true |
| postgresql.index.name | The name of the index on a table. | Any Str | true |
| postgresql.schema.name | The schema name. | Any Str | true |
| postgresql.table.name | The table name. | Any Str | true |
