[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# saphana

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### saphana.alert.count

Number of current alerts.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {alerts} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| rating | The alert rating. | Any Str |

### saphana.backup.latest

The age of the latest backup by start time.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

### saphana.column.memory.used

The memory used in all columns.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | The type of column store memory. | Str: ``main``, ``delta`` |
| subtype | The subtype of column store memory. | Str: ``data``, ``dict``, ``index``, ``misc`` |

### saphana.component.memory.used

The memory used in components.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| component | The SAP HANA component. | Any Str |

### saphana.connection.count

The number of current connections.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| status | The connection status. | Str: ``running``, ``idle``, ``queueing`` |

### saphana.cpu.used

Total CPU time spent.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| ms | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | The type of cpu. | Str: ``user``, ``system``, ``io_wait``, ``idle`` |

### saphana.disk.size.current

The disk size.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| path | The SAP HANA disk path. | Any Str |
| usage_type | The SAP HANA disk & volume usage type. | Any Str |
| state | The state of the disk storage. | Str: ``used``, ``free`` |

### saphana.host.memory.current

The amount of physical memory on the host.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| state | The state of memory. | Str: ``used``, ``free`` |

### saphana.host.swap.current

The amount of swap space on the host.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| state | The state of swap data. | Str: ``used``, ``free`` |

### saphana.instance.code_size

The instance code size, including shared libraries of SAP HANA processes.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### saphana.instance.memory.current

The size of the memory pool for all SAP HANA processes.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| state | The state of memory. | Str: ``used``, ``free`` |

### saphana.instance.memory.shared.allocated

The shared memory size of SAP HANA processes.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### saphana.instance.memory.used.peak

The peak memory from the memory pool used by SAP HANA processes since the instance started (this is a sample-based value).

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

### saphana.license.expiration.time

The amount of time remaining before license expiration.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| system | The SAP HANA system. | Any Str |
| product | The SAP HANA product. | Any Str |

### saphana.license.limit

The allowed product usage as specified by the license (for example, main memory).

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {licenses} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| system | The SAP HANA system. | Any Str |
| product | The SAP HANA product. | Any Str |

### saphana.license.peak

The peak product usage value during last 13 months, measured periodically.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {licenses} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| system | The SAP HANA system. | Any Str |
| product | The SAP HANA product. | Any Str |

### saphana.network.request.average_time

The average response time calculated over recent requests

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ms | Gauge | Double |

### saphana.network.request.count

The number of active and pending service requests.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {requests} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| state | The state of network request. | Str: ``active``, ``pending`` |

### saphana.network.request.finished.count

The number of service requests that have completed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {requests} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | The type of network request. | Str: ``internal``, ``external`` |

### saphana.replication.average_time

The average amount of time consumed replicating a log.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| us | Gauge | Double |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| primary | The primary SAP HANA host in replication. | Any Str |
| secondary | The secondary SAP HANA host in replication. | Any Str |
| port | The SAP HANA port. | Any Str |
| mode | The replication mode. | Any Str |

### saphana.replication.backlog.size

The current replication backlog size.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| primary | The primary SAP HANA host in replication. | Any Str |
| secondary | The secondary SAP HANA host in replication. | Any Str |
| port | The SAP HANA port. | Any Str |
| mode | The replication mode. | Any Str |

### saphana.replication.backlog.time

The current replication backlog.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| us | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| primary | The primary SAP HANA host in replication. | Any Str |
| secondary | The secondary SAP HANA host in replication. | Any Str |
| port | The SAP HANA port. | Any Str |
| mode | The replication mode. | Any Str |

### saphana.row_store.memory.used

The used memory for all row tables.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | The type of row store memory. | Str: ``fixed``, ``variable`` |

### saphana.schema.memory.used.current

The memory size for all tables in schema.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| schema | The SAP HANA schema. | Any Str |
| type | The type of schema memory. | Str: ``main``, ``delta``, ``history_main``, ``history_delta`` |

### saphana.schema.memory.used.max

The estimated maximum memory consumption for all fully loaded tables in schema (data for open transactions is not included).

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| schema | The SAP HANA schema. | Any Str |

### saphana.schema.operation.count

The number of operations done on all tables in schema.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {operations} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| schema | The SAP HANA schema. | Any Str |
| type | The type of operation. | Str: ``read``, ``write``, ``merge`` |

### saphana.schema.record.compressed.count

The number of entries in main during the last optimize compression run for all tables in schema.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {records} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| schema | The SAP HANA schema. | Any Str |

### saphana.schema.record.count

The number of records for all tables in schema.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {records} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| schema | The SAP HANA schema. | Any Str |
| type | The type of schema record. | Str: ``main``, ``delta``, ``history_main``, ``history_delta`` |

### saphana.service.code_size

The service code size, including shared libraries.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| service | The SAP HANA service. | Any Str |

### saphana.service.count

The number of services in a given status.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {services} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| status | The status of services. | Str: ``active``, ``inactive`` |

### saphana.service.memory.compactors.allocated

The part of the memory pool that can potentially (if unpinned) be freed during a memory shortage.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| service | The SAP HANA service. | Any Str |

### saphana.service.memory.compactors.freeable

The memory that can be freed during a memory shortage.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| service | The SAP HANA service. | Any Str |

### saphana.service.memory.effective_limit

The effective maximum memory pool size, calculated considering the pool sizes of other processes.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| service | The SAP HANA service. | Any Str |

### saphana.service.memory.heap.current

The size of the heap portion of the memory pool.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| service | The SAP HANA service. | Any Str |
| state | The state of memory. | Str: ``used``, ``free`` |

### saphana.service.memory.limit

The configured maximum memory pool size.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| service | The SAP HANA service. | Any Str |

### saphana.service.memory.shared.current

The size of the shared portion of the memory pool.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| service | The SAP HANA service. | Any Str |
| state | The state of memory. | Str: ``used``, ``free`` |

### saphana.service.memory.used

The used memory from the operating system perspective.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| service | The SAP HANA service. | Any Str |
| type | The type of service memory. | Str: ``logical``, ``physical`` |

### saphana.service.stack_size

The service stack size.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| service | The SAP HANA service. | Any Str |

### saphana.service.thread.count

The number of service threads in a given status.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {threads} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| status | The status of threads. | Str: ``active``, ``inactive`` |

### saphana.transaction.blocked

The number of transactions waiting for a lock.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {transactions} | Sum | Int | Cumulative | false |

### saphana.transaction.count

The number of transactions.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {transactions} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| type | The transaction type. | Str: ``update``, ``commit``, ``rollback`` |

### saphana.uptime

The uptime of the database.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| s | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| system | The SAP HANA system. | Any Str |
| database | The SAP HANA database. | Any Str |

### saphana.volume.operation.count

The number of operations executed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {operations} | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| path | The SAP HANA disk path. | Any Str |
| usage_type | The SAP HANA disk & volume usage type. | Any Str |
| type | The type of operation. | Str: ``read``, ``write`` |

### saphana.volume.operation.size

The size of operations executed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| By | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| path | The SAP HANA disk path. | Any Str |
| usage_type | The SAP HANA disk & volume usage type. | Any Str |
| type | The type of operation. | Str: ``read``, ``write`` |

### saphana.volume.operation.time

The time spent executing operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| ms | Sum | Int | Cumulative | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| path | The SAP HANA disk path. | Any Str |
| usage_type | The SAP HANA disk & volume usage type. | Any Str |
| type | The type of operation. | Str: ``read``, ``write`` |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| db.system | The type of database system. | Any Str | true |
| saphana.host | The SAP HANA host. | Any Str | true |
