// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"path/filepath"
	"testing"

	"github.com/google/go-cmp/cmp"
	"github.com/google/go-cmp/cmp/cmpopts"
	"github.com/stretchr/testify/require"
	"go.opentelemetry.io/collector/confmap/confmaptest"
)

func TestMetricsBuilderConfig(t *testing.T) {
	tests := []struct {
		name string
		want MetricsBuilderConfig
	}{
		{
			name: "default",
			want: DefaultMetricsBuilderConfig(),
		},
		{
			name: "all_set",
			want: MetricsBuilderConfig{
				Metrics: MetricsConfig{
					ZookeeperConnectionActive:            MetricConfig{Enabled: true},
					ZookeeperDataTreeEphemeralNodeCount:  MetricConfig{Enabled: true},
					ZookeeperDataTreeSize:                MetricConfig{Enabled: true},
					ZookeeperFileDescriptorLimit:         MetricConfig{Enabled: true},
					ZookeeperFileDescriptorOpen:          MetricConfig{Enabled: true},
					ZookeeperFollowerCount:               MetricConfig{Enabled: true},
					ZookeeperFsyncExceededThresholdCount: MetricConfig{Enabled: true},
					ZookeeperLatencyAvg:                  MetricConfig{Enabled: true},
					ZookeeperLatencyMax:                  MetricConfig{Enabled: true},
					ZookeeperLatencyMin:                  MetricConfig{Enabled: true},
					ZookeeperPacketCount:                 MetricConfig{Enabled: true},
					ZookeeperRequestActive:               MetricConfig{Enabled: true},
					ZookeeperRuok:                        MetricConfig{Enabled: true},
					ZookeeperSyncPending:                 MetricConfig{Enabled: true},
					ZookeeperWatchCount:                  MetricConfig{Enabled: true},
					ZookeeperZnodeCount:                  MetricConfig{Enabled: true},
				},
				ResourceAttributes: ResourceAttributesConfig{
					ServerState: ResourceAttributeConfig{Enabled: true},
					ZkVersion:   ResourceAttributeConfig{Enabled: true},
				},
			},
		},
		{
			name: "none_set",
			want: MetricsBuilderConfig{
				Metrics: MetricsConfig{
					ZookeeperConnectionActive:            MetricConfig{Enabled: false},
					ZookeeperDataTreeEphemeralNodeCount:  MetricConfig{Enabled: false},
					ZookeeperDataTreeSize:                MetricConfig{Enabled: false},
					ZookeeperFileDescriptorLimit:         MetricConfig{Enabled: false},
					ZookeeperFileDescriptorOpen:          MetricConfig{Enabled: false},
					ZookeeperFollowerCount:               MetricConfig{Enabled: false},
					ZookeeperFsyncExceededThresholdCount: MetricConfig{Enabled: false},
					ZookeeperLatencyAvg:                  MetricConfig{Enabled: false},
					ZookeeperLatencyMax:                  MetricConfig{Enabled: false},
					ZookeeperLatencyMin:                  MetricConfig{Enabled: false},
					ZookeeperPacketCount:                 MetricConfig{Enabled: false},
					ZookeeperRequestActive:               MetricConfig{Enabled: false},
					ZookeeperRuok:                        MetricConfig{Enabled: false},
					ZookeeperSyncPending:                 MetricConfig{Enabled: false},
					ZookeeperWatchCount:                  MetricConfig{Enabled: false},
					ZookeeperZnodeCount:                  MetricConfig{Enabled: false},
				},
				ResourceAttributes: ResourceAttributesConfig{
					ServerState: ResourceAttributeConfig{Enabled: false},
					ZkVersion:   ResourceAttributeConfig{Enabled: false},
				},
			},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			cfg := loadMetricsBuilderConfig(t, tt.name)
			diff := cmp.Diff(tt.want, cfg, cmpopts.IgnoreUnexported(MetricConfig{}, ResourceAttributeConfig{}))
			require.Emptyf(t, diff, "Config mismatch (-expected +actual):\n%s", diff)
		})
	}
}

func loadMetricsBuilderConfig(t *testing.T, name string) MetricsBuilderConfig {
	cm, err := confmaptest.LoadConf(filepath.Join("testdata", "config.yaml"))
	require.NoError(t, err)
	sub, err := cm.Sub(name)
	require.NoError(t, err)
	cfg := DefaultMetricsBuilderConfig()
	require.NoError(t, sub.Unmarshal(&cfg))
	return cfg
}

func TestResourceAttributesConfig(t *testing.T) {
	tests := []struct {
		name string
		want ResourceAttributesConfig
	}{
		{
			name: "default",
			want: DefaultResourceAttributesConfig(),
		},
		{
			name: "all_set",
			want: ResourceAttributesConfig{
				ServerState: ResourceAttributeConfig{Enabled: true},
				ZkVersion:   ResourceAttributeConfig{Enabled: true},
			},
		},
		{
			name: "none_set",
			want: ResourceAttributesConfig{
				ServerState: ResourceAttributeConfig{Enabled: false},
				ZkVersion:   ResourceAttributeConfig{Enabled: false},
			},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			cfg := loadResourceAttributesConfig(t, tt.name)
			diff := cmp.Diff(tt.want, cfg, cmpopts.IgnoreUnexported(ResourceAttributeConfig{}))
			require.Emptyf(t, diff, "Config mismatch (-expected +actual):\n%s", diff)
		})
	}
}

func loadResourceAttributesConfig(t *testing.T, name string) ResourceAttributesConfig {
	cm, err := confmaptest.LoadConf(filepath.Join("testdata", "config.yaml"))
	require.NoError(t, err)
	sub, err := cm.Sub(name)
	require.NoError(t, err)
	sub, err = sub.Sub("resource_attributes")
	require.NoError(t, err)
	cfg := DefaultResourceAttributesConfig()
	require.NoError(t, sub.Unmarshal(&cfg))
	return cfg
}
